<?php   // Zencart v1.3.9, v1.5.0    Note: The "// Zencart" is used as an initial test for a valid update file (only needs to read a few chars)

/*
  Copyright (c) 2007-2012 Rod Gasson / VCSWEB

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 	$Id: ozpost.php,V1.0.3  June 2009
	$Id: ozpost.php,V1.0.5  Oct 2009
        $Id: ozpost.php,V2.0.4  Feb 2010
        $Id: ozpost.php,V2.0.6  June 2010
        $Id: ozpost.php,V2.0.7 11 July 2010
        $Id: ozpost.php,V2.0.8 22 July 2010
        $Id: ozpost.php,V2.0.9  29 July 2010
        $Id: ozpost.php,V2.1.1  24 Oct 2010
        $Id: ozpost.php,V2.1.2  Nov 2010
        $Id: ozpost.php,V2.2.0  Dec 2010
        $Id: ozpost.php,V2.2.1  Jan 2011
        $Id: ozpost.php,V2.2.2  Feb 2011
        $Id: ozpost.php,V2.3.2  May 2011
        $Id: ozpost.php,V2.3.3  Jun 2011
        $Id: ozpost.php,V2.3.3a  Jun 2011 (GAM release)
        $Id: ozpost.php,V2.3.4  Jun 2011
        $Id: ozpost.php,V2.3.4a  Jun 2011  (GAM release)
        $Id: ozpost.php,V3.0.0   Jun 2011  Automatic update code added.
        $Id: ozpost.php,V3.0.1   Jun 2011   (auto-update release only)
             bugfix : TNT Road express/ Sensitive express not showing
             bugfix : missing closing > on span tags
        $Id: ozpost.php,V3.1.0   July 2011
             bugfix : ozpost TARE weight wasn't being added.
             bugfix : cache wasn't being used.
             bugfix : Suburb data not being sent to the servers.
             Improvement: Now uses JavaScript for suburb selection. (needs updated template file)
             Improvement: Added code to auto update template files
       $Id: ozpost.php,V3.1.1   July 2011
            bugfix: template file path error preventing auto-update from working (some zencart versions only)
        $Id: ozpost.php,V3.1.2   Sept 2011
           bugfix: Fixed Problem with javascript and IE9
           cleanup: Supressed invalid destination error on first run where postcode may be undefined
           Added: support for AUS as a currency code.
           Added: Check that $aus_rate is > 0 to avoid divide by zero error.
           Added: Override system for easy customisation of shipping method descriptions.
	$Id: ozpost.php,V3.1.3 Oct 2011
	   bugfix: Stripped some characters from storenames to prevent mod_security issues
           bugfix: Fixed issue where o/seas quotes were occasionally failing to show.
       $Id: ozpost.php,V3.2.0 Feb 2012
	   bugfix: Prepacked items not being re-orientated
           New feature: Added Click N Send CSV exports
           bugfix: A5 Satchel size was invalid
           Added: TARE Dimensions
           Improved pre-packing code
           New Methods: Ebay Flat Rate Satchels & Boxes
    $Id: ozpost.php,V3.2.1 March 2012
        New Methods:
              5kg Parcel Post Plus Satchels
              Transdirect Airfreight - Overnight
              Transdirect Airfreight - 2 Day Economy
              Transdirect Airfreight - 3 Day Offpeak
              Transdirect Airfreight - Next Flight
              Pack and Track International
       BugFix: Padded bags not always showing
       BugFix: Security surcharge missing from some quotes
       New Feature: Click n send filtered output (filters on status=2=processing)
       Change:  Click n Send CVS no longer holds duped orders. Later data with same order# now replaces the old.
    $Id: ozpost.php,V3.2.2 April 2012
            New Satchel Methods (by request): 5Kg Regular registered PPS5Kr, 500gm Platinum Insured PPSP5i, 3Kg Platinum Insured   PPSP3i
            Bugfix: Registered Air Prepaid bags were showing when Registered Air (std) was enabled.
            Bugfix: Added menu options to enable/disable Regd Air Prepaid bags.
            New option: The USA security surcharge can now be disabled (it appears not all post offices are charging this).
    $Id: ozpost.php,V3.2.3 May 2012
            New methods ECI Documents Insured, ECI Merchandice Insured
            Changed:  Regular Satchels renamed to Parcel Post+ as per Australia Post name change
            Removed Overseas insured letters (no longer an Australia Post supported option)
            Removed Insurance options for Express parcels/satchels. (no longer an Australia Post supported option)
            Fixed problem with overcharging insurance with Platinum parcels/satchels
            Fixed problem with overcharging insurance in borderline cases ($100.00, $200.00, $300.00, etc )
            Changed: USA security surcharge option is now handled serverside to prevent potential underquoting

            $Id: ozpost.php,V3.2.4 15th May 2012
            New Methods: Overseas Express letters (2 sizes)

    $Id: ozpost.php,V3.2.5 30th May 2012
            Updated Click N Send code for the CnS V2 interface.
    
   $Id: ozpost.php,V3.3.0  June 2012
         Updated installation code
         Updated shipping template to hide suburb box when not needed.
         BugFix : Ego non insured parcels were not showing
         BugFix : Trandirect was disabled unless one of the air methods was also selected
         Changes: Additional error checking
         Changes: Several cosmetic changes (mostly admin settings)  
 
    $Id: ozpost.php,V3.3.1  17th June 2012
         Bugfix  : Fixed problem of sending FastWay requests even when disabled.   
         Updated : installation code. (no longer uses fopen). 
         Updated : installation code. (Now makes a _restore file before making any changes)  
         Updated : Click N send file handling (no longer uses fopen, which was oten dissabled on the server)
         Improved: caching mechanism (faster response times) 
         Added   : tests to not modify premodified files
         Added   : tests for most likely weight factor to be used based on existing store products
         Added   : code to modify the english languages files to reflect chosen weight format 
    
 $Id: ozpost.php,V3.3.2  18th June 2012
         Bugfix : Fixed problem with missing cache table. 
         Added  : Output warning message if files have been pre-modified.
 
  $Id: ozpost.php,V3.3.3  20th June 2012
         Updated : Shortened cache expiry time to meet same day postage requirements
         Updated : Changed 'auto update' function so it now requires user action (button press & confirmation) to invoke 
         Updated : Quote form now submitted by javascript on destination changes. (No need for manual update)  
  
   $Id: ozpost.php,V3.3.4  21th June 2012
        Bugfix : PayPal Checkout got broken
       
   $Id: ozpost.php,V3.3.5  23th June 2012 
        Updated : Replaced tables with divs on quote pages
        Updated : More tweaks to the installation/update code  
 
   $Id: ozpost.php,V3.3.6  25th June 2012 
        Bugfix :  pass-by-reference error 
        Bugfix :  Jscript error with MSIE

   $Id: ozpost.php,V3.3.7  xxth June 2012 
        Change : Moved javascript to PC server (to avoid same origin reguirements for MSIE) 
        Bugfix : Ensured icons are only enabled on actual quote pages 
        BugFix : Fixed error output for EGO Couriers 
        Change : Suppressed 'harmless' errors on checkout screen to avoid screen corruption 
        Update : Installation code now updates the language files to provide correct text for weight format selected
        Update : Added Fastway pink labels
        Update : Much of the quote output page has been upgraded for performance and improved user experience. 
 */

// class constructor
class ozpost extends base {
    /**
    * Declare shipping module alias code
    * @var string
    */
   var  $code;

   /**
    * Shipping module display name
    * @var string
    */
   var $title;

   /**
    * Shipping module display description
    * @var string
    */
    var $description;

   /**
    * Shipping module icon filename/path
    * @var string
    */
   var $icon;

   /**
    * Shipping module status
    * @var boolean
    */
   var $enabled;

function ozpost() {
    
   if (!defined('ME')) define('ME', DIR_FS_CATALOG.DIR_WS_MODULES . "shipping/ozpost.php") ;  
   if (!defined('DB_PREFIX'))  define('DB_PREFIX', '');
   if (!defined('TABLE_OZPOST_CACHE')) define('TABLE_OZPOST_CACHE', DB_PREFIX.'ozpost_cache') ; 
  /*
  The following defines are examples of how to override the default *descriptions*
  of the various shipping methods. This is useful if you wish to obfuscate identifying
  any particular carrier based on this information.
 The  examples listed are used to prevent the EGO methods from being displayed as
 "EGO EGO Parcel"  &  "EGO EGO Insured Parcel"
 It does this by changing "EGO Parcel to "Parcel".
 The EGO *carrier* names are defined in the /languages/../ozpost.php file.
 If you wish to change the example defines, and/or add you own you should copy them
 into the /languages/...../ozpost.php file so as to avoid your changes being
 overwritten with the next update.
 To add/use/create your own overrides you will first need to identify the methodID code
 then append "_description" to this code (as per examples).
 You should be able identify the methodID's by looking at the 'case' commands midway in
 this code.
*/
  define('EGOi_description', 'Insured Parcel') ;
  define('EGO_description' , 'Parcel') ;
//  define('TRD_description' , 'Parcel') ;
//  define('RPP_description' , 'OzPostParcel') ;
//  define('FWS_description' , 'SlowWay Sat') ;    // Fastway Satchel override
//  define('FWL_description' , 'SlowWay Labels') ;    // Fastway label override
///////////   end of defines ///
    
global  $ipath, $Ozfiles ; 
// Ozpost Files // 
$Ozfiles = array(
            array(DIR_FS_ADMIN,   NULL                                             , "clicknsend.php"),
            array(DIR_FS_ADMIN,   DIR_WS_INCLUDES  . "extra_datafiles/"            , "clicknsend.php"),
            array(DIR_FS_ADMIN,   DIR_WS_INCLUDES  . "functions/extra_functions/"  , "init_clicknsend_dhtml.php"),
            array(DIR_FS_ADMIN,   DIR_WS_INCLUDES  . "boxes/extra_boxes/"          , "clicknsend_customers_dhtml.php"),
            array(DIR_FS_ADMIN,   DIR_WS_LANGUAGES . "english/"                    , "product.php"),
            array(DIR_FS_ADMIN,   DIR_WS_MODULES                                   , "update_product.php"),
            array(DIR_FS_ADMIN,   DIR_WS_MODULES   . "product/"                    , "collect_info.php") ,
            array(DIR_FS_CATALOG, DIR_WS_TEMPLATES . "template_default/templates/" , "tpl_modules_shipping_estimator.php"),
            array(DIR_FS_ADMIN,   DIR_WS_LANGUAGES                                 , "english.php"),
            array(DIR_FS_CATALOG, DIR_WS_LANGUAGES                                 , "english.php")
            );
        
    $ipath =  DIR_WS_IMAGES."icons/ozpost/" ;

    $this->code = 'ozpost';
    $this->VERSION = "3.3.7";
    $this->SERVER = 'ozpost.net'; //  svr0, svr1 & svr2 are prepended during lookup requests
    $this->HOST = urlencode(preg_replace('/[^A-Za-z0-9\s\s+\.\'\"\-\&]/', '', STORE_NAME ))  ;
    $this->title = MODULE_SHIPPING_OZPOST_TEXT_TITLE ;
    $this->description = "<a href =\"http://ozpost.net.au\" target=\"_blank\"/><img src=\"http://svr0.ozpost.net/favicon.ico.gif\" alt=\"http://ozpost.net.au\"></a> V$this->VERSION" ; 
    $this->sort_order = MODULE_SHIPPING_OZPOST_SORT_ORDER;

      if (zen_get_shipping_enabled($this->code)) { // disable only when entire cart is free shipping
        $this->enabled = ((MODULE_SHIPPING_OZPOST_STATUS == 'True') ? true : false);
      }

    $this->logo = "<a href =\"http://ozpost.net.au\" target=\"_blank\"/>".zen_image($ipath.'ozpost_logo.gif', 'ozpost_logo.gif')."</a>";
 
    $this->tax_class = MODULE_SHIPPING_OZPOST_TAX_CLASS;
    $this->allowed_methods = array_merge(explode(", ", MODULE_SHIPPING_OZPOST_TYPE_LETTERS), explode(", ", MODULE_SHIPPING_OZPOST_TYPE_APP),
            explode(", ", MODULE_SHIPPING_OZPOST_TYPE_APS), explode(", ", MODULE_SHIPPING_OZPOST_TYPE_FW), explode(", ", MODULE_SHIPPING_OZPOST_TYPE_TNT),
            explode(", ", MODULE_SHIPPING_OZPOST_TYPE_TRD), explode(", ", MODULE_SHIPPING_OZPOST_TYPE_EGO),explode(", ", MODULE_SHIPPING_OZPOST_TYPE_APOS), explode(", ", MODULE_SHIPPING_OZPOST_TYPE_EBAY)) ;

}

//////////////////////////////////////////////////////////////
// class methods
  function ozp_cfg_select_drop_down($select_array, $key_value, $key = '') { // can't use zen original because it exects $key_value to be an interger, we need a string 
  //  $string = '';
    $name = ((zen_not_null($key)) ? 'configuration[' . $key . ']' : 'configuration_value');
    return zen_draw_pull_down_menu($name, $select_array, $key_value);
  }
  
   function ozp_cfg_select_option($select_array, $key_value, $key = '') { //make inline instead of down // 
  $string = '';
    for ($i=0, $n=sizeof($select_array); $i<$n; $i++) {
      $name = ((zen_not_null($key)) ? 'configuration[' . $key . ']' : 'configuration_value');

      $string .= '<input type="radio" name="' . $name . '" value="' . $select_array[$i] . '"';

      if ($key_value == $select_array[$i]) $string .= ' CHECKED';

      $string .= ' id="' . strtolower($select_array[$i] . '-' . $name) . '"> ' . '<label for="' . strtolower($select_array[$i] . '-' . $name) . '" class="inputSelect">' . $select_array[$i] . '</label>&nbsp;&nbsp;';
    }
    return $string;
  } 
  
/////////////////////
function quote($method = '') {
    global $db, $order, $currencies, $parcelweight, $packageitems, $shipping_weight, $shipping_num_boxes, $ipath;

    if (zen_not_null($method) && (isset($_SESSION['ozpostQuotes'])))
    {

        $testmethod = $_SESSION['ozpostQuotes']['methods'] ;

        foreach($testmethod as $temp) {
            $search = array_search("$method", $temp) ;

            if (strlen($search) > 0 && $search >= 0) break ;
            }

        $this->quotes = array(  'id'     => $this->code,        // "ozpost"
                                'module' => $temp['txtCarrier'],  // TNT, Australia Post, FastWay etc
                                'methods' => array(array( 'id' => $method,     // unique code, eg LL1, REG, REGi.... (user selected value)
                                                          'title' => $temp['txtMethod'],  // Text string for methods type, eg Large Letter, Regular Parcel, etc
                                                          'cost' =>  $temp['cost']
                                                        )
                                                   )
                           );

        if ($this->tax_class >  0) $this->quotes['tax'] = zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);

       if (MODULE_SHIPPING_OZPOST_CSV == "Yes") $this->_clicknsend($method) ;
 
 return $this->quotes;   // return a single quote

    }  ////////////////////////////  Single Quote Exit Point //////////////////////////////////
 //////////  main //////////////////
    // default dimensions //
    $defaultdims = explode(',', MODULE_SHIPPING_OZPOST_DIMS )  ;
    $dimtare =  explode(',', MODULE_SHIPPING_OZPOST_DIMTARE )  ;
    sort($defaultdims) ; sort($dimtare) ;

    // initialise parcel variables
    $parcelwidth = 0 ; $parcellength = 0 ; $parcelheight = 0 ; $parcelweight = 0 ; $shipping_num_boxes_display = 0 ;

$dest_country = $order->delivery['country']['iso_code_2'];
        $topcode = str_replace(" ", "", ($order->delivery['postcode']));
        $aus_rate = (float) $currencies->get_value(AUD);   // get $AU exchange rate
        if ($aus_rate == 0) {
            $aus_rate = (float) $currencies->get_value(AUS); // if AUD zero/undefined then try AUS
            if ($aus_rate == 0) {
                $aus_rate = 1; // if still zero intialise to 1.00 to avoid divide by zero error
            }
        }    

        $ordervalue = $order->info['total'] / $aus_rate;

    if(($topcode == "") && ($dest_country == "AU"))  { return ; }    //  This will occur with guest user first quote where no postcode is avialalbe
    // start debug output
     if ( MODULE_SHIPPING_OZPOST_DEBUG == "Yes" ) echo "<center><table border=1 width=95% ><th colspan=8 class=messageStackWarning>Debugging information</hr>" ;

    $myorder = $_SESSION['cart']->get_products();
  // loop through cart extracting productIDs and qtys //
    for($index = 0 ; $index < count($myorder) ; $index++ ) {
      $prepacked = NULL;  $attempt = NULL; $dims = "" ;

      $id = $myorder[$index]['id'] ;   // $qty = $myorder[$index]['quantity'];
        $products_weight = $myorder[$index]['weight'];

        if (MODULE_SHIPPING_OZPOST_WEIGHT_FORMAT == "kgs") {$products_weight = $products_weight * 1000 ; } // convert to gms
        if($products_weight == 0) {$products_weight = 1 ; }  // 1 gram minimum
        $dim_query = "select products_length, products_height, products_width from " . TABLE_PRODUCTS . " where products_id='$id' limit 1 ";
        $dims = $db->Execute($dim_query);

        $dims->fields['products_height'] = ($dims->fields['products_height'] == 0) ? $defaultdims[0]:$dims->fields['products_height'] ;
        $dims->fields['products_width']  = ($dims->fields['products_width']  == 0) ? $defaultdims[1]:$dims->fields['products_width'] ;
        $dims->fields['products_length'] = ($dims->fields['products_length'] == 0) ? $defaultdims[2]:$dims->fields['products_length'] ;
       // re-orientate //
       $var = array($dims->fields['products_width'], $dims->fields['products_height'], $dims->fields['products_length']) ; sort($var) ;
       $dims->fields['products_length'] = $var[2] ; $dims->fields['products_width'] = $var[1] ;  $dims->fields['products_height'] = $var[0] ;

       ////////////////////////////
       $i = 0 ;
   while (($i < $myorder[$index]['quantity']) && (!$prepacked)) {  //  try to prepack multiple items - exit if done //

         if(($myorder[$index]['quantity'] > 1 ) && (!$attempt)) {  //  skip if attempt to prepack has failed

             $q =  $myorder[$index]['quantity'] ;

             $prepacked = $this->prepack($q,$dims->fields['products_length'],$dims->fields['products_width'],$dims->fields['products_height']) ;
            $attempt = 1 ;
            if($prepacked) {
                $dims->fields['products_length'] = $prepacked[0] ;
                $dims->fields['products_width']  = $prepacked[1] ;
                $dims->fields['products_height'] = $prepacked[2] ;
                $products_weight =  $products_weight * $q ;

            }
        }  // end Qty > 1

                // Twist the parcel
               $var = array($parcelheight, $parcellength, $parcelwidth) ; sort($var) ;
               $parcelheight = $var[0] ; $parcelwidth = $var[1] ; $parcellength = $var[2] ;

        // get the cube of these items
        $itemcube =  ($dims->fields['products_width'] * $dims->fields['products_height'] * $dims->fields['products_length'] ) ;
        // Increase widths and length of parcel as needed
        if ($dims->fields['products_width'] >  $parcelwidth)  $parcelwidth  = $dims->fields['products_width']  ;
        if ($dims->fields['products_length'] > $parcellength) $parcellength = $dims->fields['products_length'] ;

        $parcelheight +=  $dims->fields['products_height'] ;   // Stack on top on existing items
        $parcelweight +=  $products_weight ;
        $packageitems++ ;

        // Useful debugging information //
        if ( MODULE_SHIPPING_OZPOST_DEBUG == "Yes" ) {
             $q =  "-".($i+1)  ;

              if ($prepacked) {
                $q = " (".$myorder[$index]['quantity']."x) prepacked ".$prepacked[3]."x".$prepacked[4]."x".$prepacked[5]."<br>Size: ".$prepacked[6] ;
                $q .=  ($prepacked[7] > 0) ? "<br>(".$prepacked[7]." more possible)":" (Full)" ;
              }

             echo "<tr class=leftBoxHeading><th>Item " . ($index + 1) .($q)."</th><th colspan=3>" . $myorder[$index]['name'] . "</td><th colspan=4>Parcel</th></tr>
            <tr><th colspan=3>Weight</th><td>&nbsp; " . $products_weight . "gms</td>
            <th>Items</th><td>&nbsp;$packageitems</td><th>Weight</th><td>&nbsp;" ; echo $parcelweight + (($parcelweight * MODULE_SHIPPING_OZPOST_TARE )/100) ; echo "gms</td></tr>
            <tr><th>Dimensions</th><td colspan=3>&nbsp; " . $dims->fields['products_length'] . " x " . $dims->fields['products_width'] . " x "  . $dims->fields['products_height'] . "</td>
            <td colspan=4>&nbsp;$parcellength  x  $parcelwidth  x $parcelheight </td></tr>
            <tr><th>Cube / Weight</th><td colspan=3>&nbsp; " . $itemcube . "cc  / " . (($dims->fields['products_length'] * $dims->fields['products_height'] * $dims->fields['products_width']) * 0.000001 * 250) . "Kgs  </td>
            <td colspan=4>&nbsp;" . ($parcelheight * $parcellength * $parcelwidth) . "cc / " . (($parcelheight * $parcellength * $parcelwidth) * 0.000001 * 250) . "Kgs </td></tr>
            " ; }

    $i++ ;
    }    // next in Qty
}  // next item
    // package created, final twist and add tare

$var = array($parcelheight, $parcellength, $parcelwidth);
        sort($var);
        $parcelheight = $var[0] + ($dimtare[0] / 10);
        $parcelwidth = $var[1] + ($dimtare[1] / 10);
        $parcellength = $var[2] + ($dimtare[2] / 10);
        $parcelweight = $parcelweight + (($parcelweight * MODULE_SHIPPING_OZPOST_TARE ) / 100);

// OK, now we have a 'real world' package made lets see if the user requires splitting by weight.
        if (MODULE_SHIPPING_OZPOST_CORE_WEIGHT == "Yes") {
            $parcelweight = $shipping_weight;
            if (MODULE_SHIPPING_OZPOST_WEIGHT_FORMAT == "kgs")
                $parcelweight = $parcelweight * 1000;
            $parcellength = $parcellength / $shipping_num_boxes;
            // re-orientate
            $var = array($parcelheight, $parcellength, $parcelwidth);
            sort($var);
            $parcelheight = $var[0];
            $parcelwidth = $var[1];
            $parcellength = $var[2];
            $shipping_num_boxes_display = $shipping_num_boxes;
        } else {
            $shipping_num_boxes_display = 1;
        }

        if (MODULE_SHIPPING_OZPOST_RESTRAIN_DIMS == "Yes") {     // constrain to AustPost limits (Other Carriers usually accept larger)
            if ($parcellength >= 105)
                $parcellength = 105;
            if ((($parcelwidth + $parcelheight) * 2 ) >= 140) {
                $parcelwidth = 35;
                $parcelheight = 35;
            }
        }

        /// Format numbers
        $parcellength = number_format($parcellength, 2, '.', '');
        $parcelwidth = number_format($parcelwidth, 2, '.', '');
        $parcelheight = number_format($parcelheight, 2, '.', '');
        $parcelweight = intval($parcelweight); // gms

//  save dimensions for display purposes on quote form (this way we don't need to hack another system file)
        $_SESSION['parcelweight'] = $parcelweight / 1000;
        $_SESSION['swidth'] = $parcelwidth;
        $_SESSION['sheight'] = $parcelheight;
        $_SESSION['slength'] = $parcellength;
        $_SESSION['boxes'] = $shipping_num_boxes_display;
        if (MODULE_SHIPPING_OZPOST_DEBUG == "Yes") {
            echo "<center><table border=1><tr><td class=messageStackCaution>Calculated: Length=" . $parcellength . "cm, Width=" . $parcelwidth . "cm, Height=" . $parcelheight . "cm, Weight=" . $parcelweight . "gms, NumBoxes=";
            if (MODULE_SHIPPING_OZPOST_CORE_WEIGHT == "Yes") {
                echo $shipping_num_boxes . "</td></tr></table>";
            } else {
                echo "1</td></tr></table>";
            }
        }

        // Check to see if cache is useful
        if (isset($_SESSION['ozpostParcel'])) {
            $test = explode(",", $_SESSION['ozpostParcel']);

            if (($test[0] == $dest_country) && ($test[1] == $topcode) && ($test[2] == $parcelwidth) && ($test[3] == $parcelheight) &&
                    ($test[4] == $parcellength) && ($test[5] == $parcelweight) && ($test[6] == $ordervalue)) {

                if (MODULE_SHIPPING_OZPOST_DEBUG == "Yes") {
                    echo "<center><table border=1 width=95% ><td align=center><font color=\"#FF0000\">Using Cached quotes </font></td><td>";
                    print_r($_SESSION['ozpostParcel']);
                    echo "</td></tr><tr><td colspan=2>";
                    print_r($_SESSION['ozpostQuotes']);
                    echo "</td><tr></table></center>";
                }

                $this->quotes = $_SESSION['ozpostQuotes'];

                return $this->quotes; ///  Cache Exit Point //////////////////////////////////
            } // No cache match -  get new quote from server //
        }  // No cache session -  get new quote from server //
///////////////////////////////////////////////////////////////////////////////////////////////
 global $messageStack;
  //  if($method) { $ermsg = "UNEXPECTED ERROR :".$method.": method requested but not cached" ;
  //$messageStack->add_session($ermsg) ;   }
    $ef = "" ; $dcode = "" ;$deadline = "" ;$leadtime = "" ;$Dsub  = "" ;$tntvars  = "" ; $methods = array() ; $cost = 0 ; $kg = 0 ; $qty = 0 ;
    // always save new session  CSV //
    $_SESSION['ozpostParcel'] = implode(",", array($dest_country, $topcode, $parcelwidth, $parcelheight, $parcellength, $parcelweight, $ordervalue, $packageitems)) ;

  // Do some prep work to create the query string ..
    // convert cm to mm 'cos thats what the server uses //
    $parcelwidth = $parcelwidth * 10 ;  $parcelheight = $parcelheight * 10 ;  $parcellength = $parcellength * 10 ;
    $fromcode = MODULE_SHIPPING_OZPOST_ORIGIN_ZIP ;
    // Set destination code ( postcode if AU, else 2 char iso country code )
   if ($dest_country == "AU") {
       $dcode = $topcode ;
    } else {
      $dcode = $dest_country ;
     if (isset($_POST['destSuburb'])) { unset($_POST['destSuburb']) ;
      $order->delivery['suburb'] = NULL;
      $order->delivery['city']  = NULL ;
        }
    }

    $flags = 0 ;
   if (MODULE_SHIPPING_OZPOST_DEBUG != "Yes")  {    // these cause the server to exit early thus 'hiding' the options serverside
 //    if ((MODULE_SHIPPING_OZPOST_HIDE_PARCEL  == "Yes" ) && ( MODULE_SHIPPING_OZPOST_TYPE_LETTERS != "--none--" ))  $flags = $flags | 1 ; ///  hide all parcels if letter rates (original code - obsolete)
     if (MODULE_SHIPPING_OZPOST_HIDE_PARCEL2 == "Yes" )  $flags = $flags | 2  ;  //  hide parcels if satchel sized
     if (MODULE_SHIPPING_OZPOST_HIDE_COURIER == "Yes" )  $flags = $flags | 4  ;//  hide couriers if AP can handle

     if (MODULE_SHIPPING_OZPOST_HIDE_PARCELD == "Yes" )  $flags = $flags | 8  ;  //  hide all parcels if letter rates and domestic (supercedes flags=1)
     if (MODULE_SHIPPING_OZPOST_HIDE_PARCELO == "Yes" )  $flags = $flags | 16  ; //  hide all parcels if letter rates and overseas (supercedes flags=1)
   }

      $mail = 0 ;  //  Days we mail on.
      if (strchr(MODULE_SHIPPING_OZPOST_MAILDAYS, "Monday"))    $mail = $mail | 1    ;
      if (strchr(MODULE_SHIPPING_OZPOST_MAILDAYS, "Tuesday"))   $mail = $mail | 2    ;
      if (strchr(MODULE_SHIPPING_OZPOST_MAILDAYS, "Wednesday")) $mail = $mail | 4    ;
      if (strchr(MODULE_SHIPPING_OZPOST_MAILDAYS, "Thursday"))  $mail = $mail | 8    ;
      if (strchr(MODULE_SHIPPING_OZPOST_MAILDAYS, "Friday"))    $mail = $mail | 16   ;
      if (strchr(MODULE_SHIPPING_OZPOST_MAILDAYS, "Saturday"))  $mail = $mail | 32   ;
      if (strchr(MODULE_SHIPPING_OZPOST_MAILDAYS, "Sunday"))    $mail = $mail | 64   ;

      $maildays = "&maildays=".$mail     ;

    if( MODULE_SHIPPING_OZPOST_SURCHARGE == "No" ) { $NoSurcharge = "&NoSurcharge=1" ;  } else {$NoSurcharge = "&NoSurcharge=0" ; }

      if(MODULE_SHIPPING_OZPOST_EF != "None") {     // estimated days format (Date/Days/none
           if(MODULE_SHIPPING_OZPOST_EF == "Days") { $ef = "&ef=0" ; } else { $ef = "&ef=1" ; }
      }

      if(MODULE_SHIPPING_OZPOST_DEADLINE > 0 ) {$deadline = "&deadline=".MODULE_SHIPPING_OZPOST_DEADLINE ; } // deadline for same day mailings
      if(MODULE_SHIPPING_OZPOST_LEADTIME > 0 ) {$leadtime = "&leadtime=".MODULE_SHIPPING_OZPOST_LEADTIME ; }  // leadtime for delayed mailings

    // create the TNT variables
   if ( MODULE_SHIPPING_OZPOST_TNT_ACCT != "")  {
        $TNTaccount =  MODULE_SHIPPING_OZPOST_TNT_ACCT ;  $TNTusername =  MODULE_SHIPPING_OZPOST_TNT_USER ; $TNTpassword =  MODULE_SHIPPING_OZPOST_TNT_PSWD ;
        $tntvars = "&TNTaccount=".$TNTaccount."&TNTusername=".$TNTusername."&TNTpassword=".$TNTpassword ;
        }
    // create the FastWay variables //
     $fastway =  substr(strtoupper( MODULE_SHIPPING_OZPOST_FWF ),0,3) ;
      if($fastway == "DIS") $fastway = NULL ; 
     $fwvars = ($fastway) ? "&FastWay=".$fastway:"" ;
     if ( MODULE_SHIPPING_OZPOST_FW_FREQ == "Yes" )  $fwvars .= "f" ; // 'f' = frequent user flag/trigger/id

     // create the other courier variables
    if (count(preg_grep("/Transdirect/", $this->allowed_methods)) > 0)  $transvars = "&TransDirect=1"  ;
    if (count(preg_grep("/e-go.com.au/", $this->allowed_methods)) > 0)  $egovars = "&ego=1"  ;

    // Get and use Suburb names if available - (mainly for couriers due to the way their zones are organised)
    if (MODULE_SHIPPING_OZPOST_ORIGIN_SUBURB != "" )  $Osub = "&Osub=".urlencode(MODULE_SHIPPING_OZPOST_ORIGIN_SUBURB) ;

     if (isset($_POST['destSuburb'])) { $Dsub = "&Dsub=".urlencode($_POST['destSuburb']) ;     }
     else if ( $order->delivery['city'] != "" )   { $Dsub = "&Dsub=".urlencode($order->delivery['city']) ; }
     else if ( $order->delivery['suburb'] != "" ) { $Dsub = "&Dsub=".urlencode($order->delivery['suburb']) ; }

   $AllSat = "&AllSat=1" ; // if satchels are filtered here return all, else server only returns most suited.
   $query = "/postage.php?weight=$parcelweight&height=$parcelheight&width=$parcelwidth&length=$parcellength&value=$ordervalue&fromcode=$fromcode$Osub&destcode=$dcode$Dsub&flags=$flags&host=$this->HOST&storecode=".SHIPPING_ORIGIN_ZIP."&version=$this->VERSION$tntvars$fwvars$transvars$egovars$ef$deadline$maildays$leadtime$AllSat$NoSurcharge";

    $result = $this->_getURL($this->SERVER, $query) ;

    // Parse the .xml results into an array //
     if(((substr($result, 0, 7)) != "<error>") && ($result)) {   // Server error

    $xmlQuotes = new SimpleXMLElement($result)  ;

      $order->delivery['city'] = urldecode((string)$xmlQuotes->information[0]->destsuburb); // This what the *server* used. Should be same as client specified, but not always (due to typo's, Saint vs St. etc)

       $orig =  urldecode((string)($xmlQuotes->information[0]->fromsuburb)) ;
     if ( MODULE_SHIPPING_OZPOST_ORIGIN_SUBURB != $orig ) {
        $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = \"$orig\" where configuration_key = \"MODULE_SHIPPING_OZPOST_ORIGIN_SUBURB\"" );
        }

  if ( MODULE_SHIPPING_OZPOST_DEBUG == "Yes" )  { echo "<td class=messageStackWarning><strong>QueryString<strong><br>$query</td><tr><td><strong>Server Returned:<br></strong><textarea rows=20>" ; print_r($result) ; echo "</textarea></td></tr></table>" ; }

  $ozicon = (strstr($_SERVER['REQUEST_URI'] , "main_page=checkout_shipping" )) ? $this->logo:" " ;  // no icon  unless checking out (where it only shows once - as a label)
//  $ozicon = $this->logo ;
// $this->icon = $this->logo ;
    ////   Expiration Email management \\
    $days = intval($xmlQuotes->information[0]->expires) ;
    if (($days <= 7) && ($days > 0) && ( MODULE_SHIPPING_OZPOST_EMAIL_FLAG == 0)) {

        $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = 1 where configuration_key = \"MODULE_SHIPPING_OZPOST_EMAIL_FLAG\"" );
        zen_mail("Store Admin", STORE_OWNER_EMAIL_ADDRESS, "Important Notice", "Please be advised that your subscription to ozpost.net will expire in ". $days ." Days. <br>Subscriptions can be renewed at http://shop.vcsweb.com/index.php?main_page=product_info&cPath=43&products_id=207", "The Ozpost Shipping Module", EMAIL_FROM ) ;
      }

           if (($days <= 3) && ($days > 0) && ( MODULE_SHIPPING_OZPOST_EMAIL_FLAG < 2)) {
             $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = 2 where configuration_key = \"MODULE_SHIPPING_OZPOST_EMAIL_FLAG\"" );
            zen_mail("Store Admin", STORE_OWNER_EMAIL_ADDRESS, "Warning", "Please be advised that your subscription to ozpost.net will expire in ". $days ." Days. <br>Subscriptions can be renewed at http://shop.vcsweb.com/index.php?main_page=product_info&cPath=43&products_id=207", "The Ozpost Shipping Module", EMAIL_FROM ) ;
            }


  if (($days <= 0) && ( MODULE_SHIPPING_OZPOST_EMAIL_FLAG < 3) && (MODULE_SHIPPING_OZPOST_EMAIL_FLAG != 0)) {
        $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = 3 where configuration_key = \"MODULE_SHIPPING_OZPOST_EMAIL_FLAG\"" );
            zen_mail("Store Admin", STORE_OWNER_EMAIL_ADDRESS, "ERROR ALERT", "Your subscription to ozpost.net HAS EXPIRED.<br> Subscriptions can be renewed at http://shop.vcsweb.com/index.php?main_page=product_info&cPath=43&products_id=207", "The Ozpost Shipping Module", EMAIL_FROM ) ;
        }


     if (($days > 7) && ( MODULE_SHIPPING_OZPOST_EMAIL_FLAG != 0)) {  // Reset flag for next time
      $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = 0 where configuration_key = \"MODULE_SHIPPING_OZPOST_EMAIL_FLAG\"" );
        }

   /////////////////////////////////////////////////////////////
  //  Initialise our quote array
 $this->quotes = array('id' => $this->code, 'module' => "$ozicon" );$quote = array() ;

 $displayed = 0 ; // flags to prevent superflious Satchels/Boxes being presented
//bitmapped:  1 = reg sat,  2 = exp sat, 4 = plat sat, 8 = ECP prepaidm, 16 = EPI prepaid,
//              32 = FastWay satchels,  64 = prepaidSatch+reg , 128 Ebay Prepaid
$displayed2 = 0 ; // (flags continued. 8 bits weren't enough)
//            1 Platinum Satchels insured , 2 Parcel Post+ insured

//  loop through the quotes retrieved to get handling & service fees (rego/Insurance)//
    foreach($xmlQuotes as $quote) {

// nullify handling fee each loop so we can test for a case match (it'll get set to *something* )
        $serviceFee = NULL ;  $handlingFee = NULL;// reset foreach item
        $details = "" ; $description = "" ; $carrier = "" ;$txtCarrier = "" ;
      // loop thru methods returned matching those that are allowed
        switch ($quote->id) {

            case "Error";  // Only show errors in shopping cart and popup estimator windows,  else it can mess up screen 
               if (((strstr($_SERVER['REQUEST_URI'] , "main_page=shopping_cart")) || (strstr($_SERVER['REQUEST_URI'] , "main_page=popup_shipping_estimator"))) && (MODULE_SHIPPING_OZPOST_MSG == "Yes"))  {
               echo "<div class=\"messageStackCaution\">" . "$quote->description" . "</div>"; }
            break;

            case "SLET";
            case "LL1";
            case "LL2";
            case "LL3";
                if (((in_array("Aust Standard", $this->allowed_methods)) && $dest_country == "AU") || ((in_array("Overseas Standard", $this->allowed_methods)) && $dest_country != "AU")) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_LET_HANDLING;
                        if (defined('LETTER_description'))  $quote->description = LETTER_description;
                }
                break;

            case "REGL";
            case "REGLS";
            case "REGLL";
                if (((in_array("Aust Registered", $this->allowed_methods)) && $dest_country == "AU") || ((in_array("Overseas Registered", $this->allowed_methods)) && $dest_country != "AU")) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_LET_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                    $serviceFee = (float) $xmlQuotes->information[0]->registration;
                        if (defined('REGLETTER_description'))  $quote->description = REGLETTER_description;
                }
                break;

            case "SLETi";
            case "LL1i";
            case "LL2i";
            case "LL3i";
                if (((in_array("Aust Insured", $this->allowed_methods)) && $dest_country == "AU") || ((in_array("Overseas Insured", $this->allowed_methods)) && $dest_country != "AU")) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_LET_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                    $serviceFee = (float) $xmlQuotes->information[0]->insurance + (float) $xmlQuotes->information[0]->registration;
                        if (defined('INSLETTER_description'))  $quote->description = INSLETTER_description;
                }
                break;

            case "EXLS";
            case "EXLL";
                if (((in_array("Aust Express", $this->allowed_methods)) && $dest_country == "AU") || ((in_array("Overseas Express", $this->allowed_methods)) && $dest_country != "AU")) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_LET_HANDLING + MODULE_SHIPPING_OZPOST_EXP_HANDLING;
                        if (defined('EXLETTER_description')) $quote->description = EXLETTER_description;
                }
                break;

        //////////  satchels ////
            case "PPS5";
            case "PPS5K";
            case "PPS3";
                if (!($displayed & 1)) {   //  only one per group
                    if ((in_array("500gm Parcel Post+", $this->allowed_methods)) && ($quote->id == "PPS5")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING;
                            if (defined('PPS5_description'))  $quote->description = PPS5_description;
                    } else if ((in_array("3Kg Parcel Post+", $this->allowed_methods)) && ($quote->id == "PPS3")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING;
                            if (defined('PPS3_description'))  $quote->description = PPS3_description;
                    } else if ((in_array("5Kg Parcel Post+", $this->allowed_methods)) && ($quote->id == "PPS5K")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING;
                            if (defined('PPS5K_description')) $quote->description = PPS5K_description; 
                    }
               if (isset($handlingFee)) $displayed = $displayed | 1 ;}
                break;

            case "PPS5r";
            case "PPS3r";
            case "PPS5Kr";
                if (!($displayed & 64)) {   //  only one per group
                    if ((in_array("500gm Parcel Post+ Registered", $this->allowed_methods)) && ($quote->id == "PPS5r")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('PPS5r_description'))  $quote->description = PPS5r_description;
                        $serviceFee = $xmlQuotes->information[0]->registration;
                    } else
                    if ((in_array("3Kg Parcel Post+ Registered", $this->allowed_methods)) && ($quote->id == "PPS3r")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('PPS3r_description'))  $quote->description = PPS3r_description;
                        $serviceFee = $xmlQuotes->information[0]->registration;
                    } else
                    if ((in_array("5Kg Parcel Post+ Registered", $this->allowed_methods)) && ($quote->id == "PPS5Kr")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('PPS5Kr_description'))  $quote->description = PPS5Kr_description;
                        $serviceFee = $xmlQuotes->information[0]->registration;
                    }
               if (isset($handlingFee)) $displayed = $displayed | 64 ;}
                break;

            case "PPS5i";
            case "PPS3i";
            case "PPS5Ki";
                if (!($displayed2 & 2 )) {   //  only one per group
                    if ((in_array("500gm Parcel Post+ Insured", $this->allowed_methods)) && ($quote->id == "PPS5i")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('PPS5i_description'))  $quote->description = PPS5i_description;
                        $serviceFee = (float) $xmlQuotes->information[0]->insurance + (float) $xmlQuotes->information[0]->registration;
                    } else
                    if ((in_array("3Kg Parcel Post+ Insured", $this->allowed_methods)) && ($quote->id == "PPS3i")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('PPS3i_description'))  $quote->description = PPS3i_description;
                        $serviceFee = (float) $xmlQuotes->information[0]->insurance + (float) $xmlQuotes->information[0]->registration;
                    } else
                    if ((in_array("5Kg Parcel Post+ Insured", $this->allowed_methods)) && ($quote->id == "PPS5Ki")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPS_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('PPS5Ki_description')) $quote->description = PPS5Ki_description;
                        $serviceFee = (float) $xmlQuotes->information[0]->insurance + (float) $xmlQuotes->information[0]->registration;
                    }
                
                    if (isset($handlingFee)) $displayed2 = $displayed2 | 2;
                }

                break;

            case "PPSE5";
            case "PPSE3";
            case "PPSE3XL";
            case "PPSE5K";
            case "PPSE5KXL";
                if (!($displayed & 2)) {   //  only one per group
                    if ((in_array("500gm Express", $this->allowed_methods)) && ($quote->id == "PPSE5")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSE_HANDLING;
                            if (defined('PPSE5_description')) $quote->description = PPSE5_description;
                    } else
                    if ((in_array("3Kg Express", $this->allowed_methods)) && ($quote->id == "PPSE3")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSE_HANDLING;
                            if (defined('PPSE3_description'))  $quote->description = PPSE3_description;
                    } else
                    if ((in_array("3Kg XL Express", $this->allowed_methods)) && ($quote->id == "PPSE3XL")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSE_HANDLING;
                            if (defined('PPSE3XL_description')) $quote->description = PPSE3XL_description;
                    } else
                    if ((in_array("5Kg Express", $this->allowed_methods)) && ($quote->id == "PPSE5K")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSE_HANDLING;
                            if (defined('PPSE5K_description')) $quote->description = PPSE5K_description;
                    } else
                    if ((in_array("5kg XL Express", $this->allowed_methods)) && ($quote->id == "PPSE5KXL")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSE_HANDLING;
                            if (defined('PPSE5KXL_description')) $quote->description = PPSE5KXL_description;
                    }
                if (isset($handlingFee)) $displayed = $displayed | 2;
                }
               break;

            case "PPSP5";
            case "PPSP3";

                if (!($displayed & 4)) {   //  only one per group
                    if ((in_array("500gm Platinum", $this->allowed_methods)) && ($quote->id == "PPSP5")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSP_HANDLING;
                            if (defined('PPSP5_description'))  $quote->description = PPSP5_description;
                    } else
                    if ((in_array("3Kg Platinum", $this->allowed_methods)) && ($quote->id == "PPSP3")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSP_HANDLING;
                            if (defined('PPSP3_description')) $quote->description = PPSP3_description;
                    }
                if (isset($handlingFee)) $displayed = $displayed | 4; 
 }
                break;


            case "PPSP5i";
            case "PPSP3i";
                if (!($displayed2 & 1)) {   //  only one per group
                    if ((in_array("500gm Platinum Insured", $this->allowed_methods)) && ($quote->id == "PPSP5i")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('PPSP5i_description')) $quote->description = PPSP5i_description;
                        $serviceFee = $xmlQuotes->information[0]->insurance;
                    } else
                    if ((in_array("3Kg Platinum Insured", $this->allowed_methods)) && ($quote->id == "PPSP3i")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('PPSP3i_description'))  $quote->description = PPSP3i_description;
                        $serviceFee = $xmlQuotes->information[0]->insurance;
                    }
                if (isset($handlingFee)) $displayed2 = $displayed2 | 1; 
                }
                break;

            case "REG";
                if (in_array("Registered", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('REG_description'))  $quote->description = REG_description;
                    $serviceFee = $xmlQuotes->information[0]->registration;
                }
                break;

            case "RPP";
                if (in_array("Regular", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_RPP_HANDLING;
                        if (defined('RPP_description'))  $quote->description = RPP_description;
                }
                break;

            case "RPPi";
                if (in_array("Insured", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('RPPi_description')) $quote->description = RPPi_description;
                    $serviceFee = (float) $xmlQuotes->information[0]->insurance + (float) $xmlQuotes->information[0]->registration;
                }
                break;

            case "EPI";
                if (in_array("Express Parcel International (EPI)", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_EXP_HANDLING;
                        if (defined('EPI_description')) $quote->description = EPI_description;
                }
                break;

            case "EXP";
                if (in_array("Express", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_EXP_HANDLING;
                        if (defined('EXP_description')) $quote->description = EXP_description;
                }
                break;

            case "EPIi";
                if (in_array("Insured Express Parcel International (EPI)", $this->allowed_methods)) {
                    $serviceFee = $xmlQuotes->information[0]->insurance;
                    $handlingFee = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_EXP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('EPIi_description')) $quote->description = EPIi_description;
                }
                break;

            case "PLT";
                if (in_array("Platinum", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_PLT_HANDLING;
                        if (defined('PLT_description'))  $quote->description = PLT_description;
                }
                break;

            case "PLTi";
                if (in_array("Insured Platinum", $this->allowed_methods)) {
                    $serviceFee = $xmlQuotes->information[0]->insurance;
                    $handlingFee = MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_PLT_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('PLTi_description'))  $quote->description = PLTi_description;
                }
                break;

            case "COD";
                if (in_array("Cash on Delivery", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_COD_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('COD_description'))  $quote->description = COD_description;
                }
                break;


            case "AIR";
                if (in_array("Air", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_INT_HANDLING;
                        if (defined('AIR_description'))  $quote->description = AIR_description;
                }
                break;

            case "AIRi";
                if (in_array("Insured Air", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('AIRi_description'))  $quote->description = AIRi_description;
                    $serviceFee = $xmlQuotes->information[0]->insurance;
                }
                break;

            case "AIRr";   //  RPI postpaid
                if (in_array("Registered Air", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('AIRr_description'))  $quote->description = AIRr_description;
                    $serviceFee = $xmlQuotes->information[0]->registration;
                }
                break;

            case "RPIPP5";    // RPI prepaid
            case "RPIPP1";
                if (!($displayed2 & 2)) {   //  only one per group
                    if ((in_array("Registered Air 500gm Prepaid bag", $this->allowed_methods)) && ($quote->id == "RPIPP5")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('RPIPP5_description')) $quote->description = RPIPP5_description;
                    } else
                    if ((in_array("Registered Air 1kg Prepaid bag", $this->allowed_methods)) && ($quote->id == "RPIPP1")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_PPSP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                            if (defined('RPIPP1_description'))  $quote->description = RPIPP1_description;
                    }
                if (isset($handlingFee)) $displayed2 = $displayed2 | 2;        
                }
                break;

            case "PAT";
                if (in_array("Pack and Track", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING ;
                        if (defined('PAT_description'))  $quote->description = PAT_description ;
                }
                break;

            case "SEA";
                if (in_array("Sea", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_INT_HANDLING;
                        if (defined('SEA_description')) $quote->description = SEA_description;
                }
                break;

            case "SEAi";
                if (in_array("Insured Sea", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('SEAi_description'))  $quote->description = SEAi_description;
                    $serviceFee = $xmlQuotes->information[0]->insurance;
                }
                break;

            case "ECIm";
                if (in_array("Express Courier International Merchandise (ECI)", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                        if (defined('ECIm_description'))  $quote->description = ECIm_description;
                }
                break;

            case "ECId":
                if (in_array("Express Courier International Documents (ECI)", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_ECID_HANDLING;
                        if (defined('ECId_description'))  $quote->description = ECId_description;
                }
                break;

            case "ECImi";
                if (in_array("Express Courier International Merchandise Insured (ECI)", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                        if (defined('ECImi_description'))  $quote->description = ECIm_description;
                }
                break;

            case "ECIdi":
                if (in_array("Express Courier International Documents Insured (ECI)", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_ECID_HANDLING;
                        if (defined('ECIdi_description'))  $quote->description = ECId_description;
                }
                break;


            case "ECIP500g";
            case "ECIP1";
            case "ECIP2";
            case "ECIP3";
            case "ECIP5k";
            case "ECIP10";
            case "ECIP20";
                if (!($displayed & 8)) {   //  only one per group
                    if ((in_array("ECI 500gm Prepaid Satchel", $this->allowed_methods)) && ($quote->id == "ECIP500g")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                            if (defined('ECIP500g_description'))  $quote->description = ECIP500g_description;
                    } elseif ((in_array("ECI 1Kg Prepaid Satchel", $this->allowed_methods)) && ($quote->id == "ECIP1")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                            if (defined('ECIP1_description'))  $quote->description = ECIP1_description;
                    } elseif ((in_array("ECI 2Kg Prepaid Satchel", $this->allowed_methods)) && ($quote->id == "ECIP2")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                            if (defined('ECIP2_description'))  $quote->description = ECIP2_description;
                    } elseif ((in_array("ECI 3Kg Prepaid Satchel", $this->allowed_methods)) && ($quote->id == "ECIP3")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                            if (defined('ECIP3_description'))   $quote->description = ECIP3_description;
                    } elseif ((in_array("ECI 5Kg Prepaid Box", $this->allowed_methods)) && ($quote->id == "ECIP5k")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                            if (defined('ECIP5k_description'))  $quote->description = ECIP5k_description;
                    } elseif ((in_array("ECI 10Kg Prepaid Box", $this->allowed_methods)) && ($quote->id == "ECIP10")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                            if (defined('ECIP10_description'))  $quote->description = ECIP10_description;
                    } elseif ((in_array("ECI 20Kg Prepaid Box", $this->allowed_methods)) && ($quote->id == "ECIP20")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_ECIM_HANDLING;
                            if (defined('ECIP20_description'))  $quote->description = ECIP20_description;
                    }
                if (isset($handlingFee)) $displayed = $displayed | 8;
               }
                break;

            //////////////////////////////////////
            ///  EPI prepaid - only one per group
            case "EPIP2";
            case "EPIP3";
            case "EPIP5";
            case "EPIP10";
            case "EPIP20";
                if (!($displayed & 16)) {   //  only one per group
                    if ((in_array("EPI 2Kg Prepaid Satchel", $this->allowed_methods)) && ($quote->id == "EPIP2")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EPI_HANDLING;
                            if (defined('EPIP2_description'))  $quote->description = EPIP2_description;
                    } elseif ((in_array("EPI 3Kg Prepaid Satchel", $this->allowed_methods)) && ($quote->id == "EPIP3")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EPI_HANDLING;
                            if (defined('EPIP3_description'))  $quote->description = EPIP3_description;
                    } elseif ((in_array("EPI 5Kg Prepaid Box", $this->allowed_methods)) && ($quote->id == "EPIP5")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EPI_HANDLING;
                            if (defined('EPIP5k_description'))   $quote->description = EPIP5k_description;
                    } elseif ((in_array("EPI 10Kg Prepaid Box", $this->allowed_methods)) && ($quote->id == "EPIP10")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EPI_HANDLING;
                            if (defined('EPIP10_description'))  $quote->description = EPIP10_description;
                    } elseif ((in_array("EPI 20Kg Prepaid Box", $this->allowed_methods)) && ($quote->id == "EPIP20")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EPI_HANDLING;
                            if (defined('EPIP20_description'))  $quote->description = EPIP20_description;
                    }
                if (isset($handlingFee)) $displayed = $displayed | 16;
                }

                break;

            case "TNT712"; // 9am Express
                if (in_array("Overnight Express by 9:00am", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TNT_HANDLING;
                        if (defined('TNT712_description')) $quote->description = TNT712_description;
                }
                break;

            case "TNTEX10"; // 10:00 am
                if (in_array("Overnight Express by 10:00am", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TNT_HANDLING;
                        if (defined('TNTEX10_description'))  $quote->description = TNTEX10_description;
                }
                break;

            case "TNTEX12"; // 12:00 pm
                if (in_array("Overnight Express by 12:00pm", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TNT_HANDLING;
                        if (defined('TNTEX12_description'))  $quote->description = TNTEX12_description;
                }
                break;

            case "TNT75"; // overnight express by 5pm (was Overnight First Class)
                if (in_array("Overnight Express by 5:00pm", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TNT_HANDLING;
                        if (defined('TNT75_description')) $quote->description = TNT75_description;
                }
                break;

            case "TNT76"; // Road Express
                if (in_array("Road Express", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TNT_HANDLING;
                        if (defined('TNT76_description')) $quote->description = TNT76_description;
                }
                break;

            case "TNT717B";
                if (in_array("Technology Express - Sensitive Express", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TNT_HANDLING;
                        if (defined('TNT717B_description'))  $quote->description = TNT717B_description;
                }
                break;

            case "FWL";
                if ((in_array("Brown Label",  $this->allowed_methods)) && (strstr($quote->description, "BROWN")))  $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Lime Label",   $this->allowed_methods)) && (strstr($quote->description, "LIME")))   $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Pink Label",   $this->allowed_methods)) && (strstr($quote->description, "PINK")))   $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Red Label",    $this->allowed_methods)) && (strstr($quote->description, "RED")))    $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Orange Label", $this->allowed_methods)) && (strstr($quote->description, "ORANGE"))) $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Green Label",  $this->allowed_methods)) && (strstr($quote->description, "GREEN")))  $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("White Label",  $this->allowed_methods)) && (strstr($quote->description, "WHITE")))  $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Grey Label",   $this->allowed_methods)) && (strstr($quote->description, "GREY")))   $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Black Label",  $this->allowed_methods)) && (strstr($quote->description, "BLACK")))  $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Blue Label",   $this->allowed_methods)) && (strstr($quote->description, "BLUE")))   $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
                if ((in_array("Yellow Label", $this->allowed_methods)) && (strstr($quote->description, "YELLOW"))) $handlingFee = MODULE_SHIPPING_OZPOST_FWL_HANDLING;
              
                if (defined('FWL_description'))  $quote->description = FWL_description;
                break;

            case "FWS":
                if (!($displayed & 32)) {   //  only one per group
                    if ((in_array("A5 Satchel (1Kg)", $this->allowed_methods)) && (strstr($quote->description, "A5 Satchel (BLUE)"))) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_FWS_HANDLING;
                    } elseif ((in_array("A3 Satchel (local)", $this->allowed_methods)) && (strstr($quote->description, "A3 Satchel (ORANGE)"))) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_FWS_HANDLING;
                    } elseif ((in_array("A3 Satchel (3Kg)", $this->allowed_methods)) && (strstr($quote->description, "A3 Satchel (BLUE)"))) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_FWS_HANDLING;
                    } elseif ((in_array("A2 Satchel (5Kg)", $this->allowed_methods)) && (strstr($quote->description, "A2 Satchel (BLUE)"))) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_FWS_HANDLING;
                    }
                            if (defined('FWS_description'))  $quote->description = FWS_description;
                if (isset($handlingFee)) $displayed = $displayed | 32 ;    
               }
                break;

            case "TRD":
                if (in_array("Transdirect Road Express", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TRD_HANDLING;
                        if (defined('TRD_description')) $quote->description = TRD_description;
                }
                break;

            case "TRDa1":
                if (in_array("Transdirect Airfreight - Overnight", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TRD_HANDLING;
                        if (defined('TRDa1_description')) $quote->description = TRDa1_description;
                }
                break;

            case "TRDa2":
                if (in_array("Transdirect Airfreight - 2 Day Economy", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TRD_HANDLING;
                        if (defined('TRDa2_description')) $quote->description = TRDa2_description;
                }
                break;

            case "TRDa3":
                if (in_array("Transdirect Airfreight - 3 Day Offpeak", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TRD_HANDLING;
                        if (defined('TRDa3_description'))  $quote->description = TRDa3_description;
                }
                break;

            case "TRDnf":
                if (in_array("Transdirect Airfreight - Next Flight", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_TRD_HANDLING;
                        if (defined('TRDnf_description'))  $quote->description = TRDnf_description;
                }
                break;

            case "EGO":
                if (in_array("e-go.com.au", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_EGO_HANDLING;
                        if (defined('EGO_description'))  $quote->description = EGO_description;
                }

                break;

            case "EGOi":
                if (in_array("Insured e-go.com.au", $this->allowed_methods)) {
                    $handlingFee = MODULE_SHIPPING_OZPOST_EGO_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING;
                        if (defined('EGOi_description'))  $quote->description = EGOi_description;
                    $serviceFee = $xmlQuotes->information[0]->egoinsurance;
                }

                break;

            case "EBAY39712":
            case "EBAY39715":
            case "EBAYBx1":
            case "EBAYBx2":
            case "EBAYBx3":
                if (!($displayed & 128)) {   //  only one per group
                    if ((in_array("500gm Satchel", $this->allowed_methods)) && ($quote->id == "EBAY39712")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EBAYS_HANDLING;
                            if (defined('EBAY39712_description'))  $quote->description = EBAY39712_description;
                    } elseif ((in_array("3kg Satchel", $this->allowed_methods)) && ($quote->id == "EBAY39715")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EBAYS_HANDLING;
                            if (defined('EBAY39715_description'))$quote->description = EBAY39715_description;
                    } elseif ((in_array("Small box 15kg (A5)", $this->allowed_methods)) && ($quote->id == "EBAYBx1")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EBAYB_HANDLING;
                            if (defined('EBAYBx1_description'))   $quote->description = EBAYBx1_description;
                    } elseif ((in_array("Medium box 15kg (A4)", $this->allowed_methods)) && ($quote->id == "EBAYBx2")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EBAYB_HANDLING;
                            if (defined('EBAYBx2_description'))  $quote->description = EBAYBx2_description;
                    } elseif ((in_array("Large box 15kg (A3)", $this->allowed_methods)) && ($quote->id == "EBAYBx3")) {
                        $handlingFee = MODULE_SHIPPING_OZPOST_EBAYB_HANDLING;
                            if (defined('EBAYBx3_description')) $quote->description = EBAYBx3_description;
                    }

                if (isset($handlingFee)) $displayed = $displayed | 128;
                }  
               break;
        }

 /////////////////////////////
    if (isset($handlingFee) && ($quote->cost > 0)) {  // valid quote

        if ( MODULE_SHIPPING_OZPOST_CORE_WEIGHT == "Yes") $quote->cost = (float)$quote->cost * $shipping_num_boxes ;

        $cost = (float)($quote->cost) + $handlingFee ;
        $surcharge = (float)$xmlQuotes->information[0]->surcharge ;


        if ( MODULE_SHIPPING_OZPOST_CORE_WEIGHT == "Yes") { $cost = $cost + ($handlingFee * ($shipping_num_boxes - 1)) ; $handlingFee =  $handlingFee * $shipping_num_boxes ;}
        if ($cost < 0) {  $handlingFee = 0-(float)($quote->cost) ;  $cost = 0 ;   }
        
    switch (substr($quote->id, 0, 2)) {
                        case "TN": $txtCarrier = MODULE_SHIPPING_OZPOST_TNT_TEXT; $logo = 'ozpost_tnt_logo.' ; 
                        break;

                        case "EG": $txtCarrier = MODULE_SHIPPING_OZPOST_EGO_TEXT;  $logo = 'ozpost_ego_logo.' ;
                        break;

                        case "FW": $txtCarrier = MODULE_SHIPPING_OZPOST_FASTWAY_TEXT; $logo = 'ozpost_fastway_logo.';
                        break;

                        case "TR":  $txtCarrier = MODULE_SHIPPING_OZPOST_TRANSD_TEXT;  $logo = 'ozpost_trd_logo.' ;
                        break;

                        default: $txtCarrier = MODULE_SHIPPING_OZPOST_AP_TEXT; $logo = 'ozpost_austpost_logo.' ;
                   }
            
            $description = $quote->description ;
            $carrier =   $txtCarrier . ",";    
                            // Icons only in shopping cart and estimation pages, else it messes PayPal low quote selection
            if (((strstr($_SERVER['REQUEST_URI'] , "main_page=shopping_cart")) || (strstr($_SERVER['REQUEST_URI'] , "main_page=popup_shipping_estimator"))) && (MODULE_SHIPPING_OZPOST_ICONS <> "none" ))  {
           
                $logo =  $ipath.$logo. MODULE_SHIPPING_OZPOST_ICONS;    
                if(zen_not_null($logo)) $carrier = zen_image($logo, $txtCarrier) ;
    
                if (is_file($ipath."ozpost_".strtolower($quote->id).".". MODULE_SHIPPING_OZPOST_ICONS)) {  // only if icon exists
                    $description = zen_image($ipath."ozpost_".strtolower($quote->id).".". MODULE_SHIPPING_OZPOST_ICONS, $quote->description ) ; 
             }

   }              
       if (($dest_country == "AU") && (($this->tax_class) > 0)) {
                $t = $cost - ($cost / (zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id'])+1)) ;
                if ($t > 0) $cost = $t ;
       }


$estimateddays = NULL ;
 if (MODULE_SHIPPING_OZPOST_EF != "None") {
             $estimateddays = $quote->days ;
             if (MODULE_SHIPPING_OZPOST_EF == "Days")  $estimateddays .=  MODULE_SHIPPING_OZPOST_EST_DEL_TEXT  ; 
        }

           
if ( MODULE_SHIPPING_OZPOST_CORE_WEIGHT == "Yes" && $shipping_num_boxes > 1 ) {
      $description .= "(x".$shipping_num_boxes.")"; $quote->description = $quote->description." (x".$shipping_num_boxes.")" ;
     } 
            
 $carrier = "<div style='display:inline;'>".$carrier . " " . $description . "<div style='display:inline;vertical-align:top;float:right;'>".$estimateddays ."&nbsp;&nbsp;&nbsp;</div></div>" ;
      
 $details = NULL ;
 if  (MODULE_SHIPPING_OZPOST_HIDE_HANDLING !='Yes') {
              $details =  "<div style='display:inline;vertical-align:top;float:right;'>" ; 
              $details = ($handlingFee > 0) ? $details .= MODULE_SHIPPING_OZPOST_HANDLING1_TEXT . $currencies->format((float)$handlingFee / $aus_rate). MODULE_SHIPPING_OZPOST_HANDLING2_TEXT: $details = $details  ;
              $details = ($serviceFee > 0)  ? $details .= "<br>". MODULE_SHIPPING_OZPOST_HANDLING1_TEXT . $currencies->format((float)$serviceFee / $aus_rate). " Reg/Ins fee" : $details = $details  ;
              $details = ($surcharge > 0)   ? $details .= "<br>". MODULE_SHIPPING_OZPOST_HANDLING1_TEXT . $currencies->format((float)$surcharge / $aus_rate) ." USA security surcharge" : $details = $details  ;
              $details .= "</div>"  ;
           }

          // store it //
      $methods[] = array('id' => "$quote->id",  'title' => "$carrier"."$details", 'cost' => ($cost / $aus_rate),'txtCarrier' => $txtCarrier,'txtMethod' => "$quote->description");

        }   // end  if  if ((isset($handlingFee)) && ($quote->cost > 0))
    }  // end foreach loop

}  else  { //  SERVER CONNECTION ERROR

    if ( MODULE_SHIPPING_OZPOST_MSG == "Yes") {
        echo "<div class=\"messageStackError\">". MODULE_SHIPPING_OZPOST_ERROR_TEXT2 .$result."</div>";
    }
  } //  SERVER CONNECTION ERROR END

///////////////////////////////////////////////////////////////////////
//  check to ensure we have at least one valid quote - produce use fixed rates if not.

if  (sizeof($methods) == 0 ) {
    $cost = $this->_get_error_cost($dest_country, $kg, $qty) ;
        if ($cost[0] == 0)  return  ;
   $methods[] = array( 'id' => " ",  'title' =>  " $".$cost[1] , 'cost' => $cost[0], 'txtCarrier' => " ",'txtMethod' => $cost[1] . MODULE_SHIPPING_OZPOST_COST_ON_ERROR_TYPE ) ;
}

    //  Sort by cost //
    $sarray = array() ;  $resultarr = array() ;

    foreach($methods as $key => $value)  $sarray[ $key ] = $value['cost'] ;
       asort($sarray) ;
    foreach($sarray as $key => $value)  $resultarr[ $key ] = $methods[ $key ] ;

    $this->quotes['methods'] = array_values($resultarr) ;   // set it

    if ($this->tax_class >  0) $this->quotes['tax'] = zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);

$_SESSION['ozpostQuotes'] = $this->quotes  ; // save as session to avoid reprocessing when single method required
$_SESSION['ozpostOrigState'] = (string)$xmlQuotes->information[0]->origstate ;
// print_r($this->quotes) ;  exit ;

// $this->quotes['icon'] = $this->logo ; 
return $this->quotes;   //  all done //

} //  end function quote($method = '')   ***** Final Exit Point ***********

private function _get_error_cost($dest_country) {
global $parcelweight, $packageitems;

 $x = explode(',', MODULE_SHIPPING_OZPOST_COST_ON_ERROR) ;

        unset($_SESSION['ozpostParcel']) ;  // don't cache errors.
        $rate = ($dest_country == "AU")  ?  $x[0]:$x[1] ;
        $cost = $rate ;
               if ( MODULE_SHIPPING_OZPOST_COST_ON_ERROR_TYPE == "Cost per Kg") { $cost = $rate * intval(($parcelweight/1000) + 1) ; }
                if ( MODULE_SHIPPING_OZPOST_COST_ON_ERROR_TYPE == "Cost per Item") { $cost = $rate * $packageitems ; }

        $this->quotes = array('id' => $this->code, 'module' => MODULE_SHIPPING_OZPOST_COST_ON_ERROR_TYPE );

return array($cost,$rate);
}

////////////////////////////////////////////
private function prepack($qty, $length,$width,$height)   {
$max = array();$packageTypes = array();
    $max[0][0] = 16  ; $max[0][1]  = 11 ; $packageTypes[0] = "C5" ;  // C5 envelope         176
    $max[1][0] = 17  ; $max[1][1]  = 12 ; $packageTypes[1] = "PB1" ; // PB1 padded bag      204
    $max[2][0] = 22  ; $max[2][1]  = 15 ; $packageTypes[2] = "PB2" ; // PB2 padded bag      330

    $max[3][0] = 22  ; $max[3][1]  = 16 ; $packageTypes[3] = "Bx1" ; // ebay Box1  220mm x 160mm x 77mm

    $max[4][0] = 26  ; $max[4][1]  = 19 ; $packageTypes[4] = "A5" ; // FastWay A5          494
    $max[5][0] = 28  ; $max[5][1]  = 21 ; $packageTypes[5] = "PB3" ; // PB3 padded bag      588

    $max[6][0] = 31  ; $max[6][1]  = 22 ; $packageTypes[6] = "Bx2" ; // ebay Box2 310mm x 225mm x 102mm

    $max[7][0] = 32  ; $max[7][1]  = 22 ; $packageTypes[7] = "C4" ; // C4 envelope         704
    $max[8][0] = 33  ; $max[8][1]  = 22 ; $packageTypes[8] = "500gm" ; // AustPost 500gm      770
    $max[9][0] = 38  ; $max[9][1]  = 26 ; $packageTypes[9] = "PB4" ; // PB4 padded bag      988
    $max[10][0] = 40 ; $max[10][1]  = 31 ; $packageTypes[10] = "3kg" ; // AustPost 3kg       1240

    $max[11][0] = 43 ; $max[11][1]  = 30 ; $packageTypes[11] = "Bx3" ; // ebay Box3 430mm x 305mm x 140mm

    $max[12][0] = 53 ; $max[12][1]  = 25 ; $packageTypes[12] = "B4" ; // B4 envelope        1325
    $max[13][0] = 44 ; $max[13][1] = 32 ; $packageTypes[13] = "A3" ; // FastWay A3         1408
    $max[14][0] = 48 ; $max[14][1] = 36 ; $packageTypes[14] = "PB5" ; // PB5 padded bag     1728
    $max[15][0] = 51 ; $max[15][1] = 46 ; $packageTypes[15] = "5kg" ; // AustPost 5kg       2346
    $max[16][0] = 55 ; $max[16][1] = 46 ; $packageTypes[16] = "XL" ; // AustPost XL        2530
    $max[17][0] = 61 ; $max[17][1] = 45 ; $packageTypes[17] = "A2" ; // FastWay A2         2745
  //  $max[18][0] = 105; $max[18][1] = 70 ; $packageTypes[18] = "APmax" ; // AustPost MAX (105 x 140) = flat 105x70    7350

  $result = NULL ;
  $i = 0 ;
while (($i < sizeof($max)) && (!$result))  {

        $t2 = $this->prepack_size($qty, $length,$width,$height,$max[$i][0],$max[$i][1],$packageTypes[$i]) ;
            if(($t2) && ((($i == 3) && ($t2[2] > 7.7)) || (($i == 6) && ($t2[2] > 10.2)) || (($i == 11) && ($t2[2] > 14)))) { // test box heights
        $t2 = NULL ;
   }

$result = $t2 ; // $this->prepack_size($qty, $length,$width,$height,$max[$i][0],$max[$i][1],$packageTypes[$i]) ;
$i++ ;
}
return $result;
}
/////   end prepack

private function prepack_size($qty, $length,$width,$height, $maxlength, $maxwidth,$packagetype)   {
$result = NULL ;
    $nlength = 0 ; $nwidth = 0 ; $nheight = 0 ;  $bestproductslengthqty = 0 ; $bestproductswidthqty = 0 ; $bestproductsheightqty = 0 ;

    if ( (($length + $height) < $maxlength) && ($width + $height) < $maxwidth) {  // first ensure even a single item fits

                 $productsheightqty = 1 ; $productslengthqty = 1 ; $productswidthqty = 1 ; $bestfit = 0 ;

                 $heightcounter = 1 ;
                       while (($productslengthqty > 0) &&  ($productswidthqty > 0)) { //  this will find the best fit (max products per given space)

                          $newheight = $heightcounter * $height ;
                          $newmaxlength = intval($maxlength - $newheight) ;   // increase the height = decrease the length
                          $newmaxwidth = intval($maxwidth - $newheight) ;     //  and width

                          $productslengthqty = intval($newmaxlength / $length) ; // How many fit new length (min 1)
                          $productswidthqty  = intval($newmaxwidth  / $width)  ;  // How many fit new width (min 1)

                          $productsfitqtyXYZ = $productslengthqty * $productswidthqty * $heightcounter ; // How many total

                          if (($productsfitqtyXYZ >= $bestfit) && ($productsfitqtyXYZ > 0) ) { // keep track of best fit //
                              $bestfit = $productsfitqtyXYZ ;
                              $bestproductslengthqty = $productslengthqty ;
                              $bestproductswidthqty = $productswidthqty  ;
                              $bestproductsheightqty = $heightcounter ;
                          }

                          $heightcounter++ ;  // what happens if we stack them higher? (eventually height will reduce the
                          // width or length so far the item(s) won't fit that way and the loop will exit

                       }

                       if ($bestfit >= $qty)  {   // this should always be true, esle how did we get here in the first place?

                            $productslengthqty = $bestproductslengthqty ;
                            $productswidthqty = $bestproductswidthqty  ;
                            $productsheightqty = $bestproductsheightqty ;


                 ///////// 1D
                          if($productslengthqty >= $qty) {   // SINGLE ROW
                             $nlength =  $qty * $length ;       // simply length * qty
                             $nwidth =  $width ;                 // no change
                             $nheight =  $height ;               // no change
                             $productswidthqty = 1 ;            // always 1
                             $productsheightqty = 1 ;           // always 1
                             $productslengthqty = $qty ;

                           } else
                 ///////// 2D
                          if($productslengthqty * $productswidthqty >= $qty)  {  // SINGLE LAYER
                            $nlength =  $productslengthqty * $length  ;         // simply length * qty
                            $productswidthqty = ceil($qty / $productslengthqty  ) ; // how many columns do we need?
                            $nwidth =  $productswidthqty * $width ;             //  actual width used/needed
                            $nheight =  $height ;                               // no change
                            $productsheightqty = 1 ;                            // always 1
                        }
                 ///////////  3D
                           else {                                               // MULTIPLE LAYERS
                            $nlength =  $productslengthqty * $length  ;         // simply   length * qty
                            $nwidth =  $productswidthqty * $width ;             //          width * qty
                            $productsheightqty = ceil($qty / ($productslengthqty * $productswidthqty)) ; // how many layers do we need?
                            $nheight =  $productsheightqty * $height  ;         //  actual height used/needed
                          }

    } // bestfit is less than quantity
   if(($nlength > 0 ) && ($nheight > 0 ) && ($nwidth > 0 ))  {

       $na = array($nlength,$nheight,$nwidth) ; sort($na);
         $result = array($na[2],$na[1], $na[0],$productslengthqty,$productswidthqty,$productsheightqty,$packagetype,($bestfit - $qty)) ;
     }
     }
return $result;
}
/////   end prepack

private function _clicknsend($method) {
    global  $order, $packageitems, $db  ;

    if (isset($order->delivery['street_address'])) {

    $vars = explode(",", $_SESSION['ozpostParcel']) ;

    $countryCode = $vars[0];
        $dpcode  = $vars[1];
        $pwidth  = number_format($vars[2],2);
        $pheight = number_format($vars[3],2);
        $plength = number_format($vars[4],2);
        $pweight = $vars[5];
      //  $pvalue  = number_format($order->info['subtotal'],2) ;
        $pvalue  = $order->info['subtotal'] * 100  ;

        $packageitems = $vars[7];

 if ($pwidth < 12) $pwidth = 12 ; // min wid = 12cm
 if ($pheight < 5) $pheight = 5 ;// minimum height is 5.00cm
 if ($plength < 12) $plength = 12 ; // min len = 12cm
 if ($pweight < 251) $pweight = 251 ; // min weight = 251gm


$ServiceCode = NULL;
$ins = (substr($method, 3, 1) == "i") ? 1:0 ;
$tracking = $ins ; // insurance requires tracking 

$Description = $order->products[0]['name'];

 $city = $order->delivery['city'] ;
    if(!$city)  $city = urldecode($this->_getURL($this->SERVER, "/postage.php?flags=get_suburb&fromcode=".$order->delivery['postcode'])) ;

  $state =  zen_get_zone_code($order->delivery['country_id'], $order->delivery['zone_id']) ;

$res = array() ;
$res = $db->Execute("select orders_id from " . TABLE_ORDERS . " ORDER BY  orders_id DESC LIMIT 1 ");
$ref = (int)$res->fields['orders_id'] + 1  ;
$irregular = 0 ;  // 0box  1 irregular

//  Required FROM data //
$FROM = STORE_OWNER ;
$COMPANY = $this->HOST ;
$PHONE = "" ;
$EMAIL = STORE_OWNER_EMAIL_ADDRESS ;
$ADDR = "" ;
$SUB = MODULE_SHIPPING_OZPOST_ORIGIN_SUBURB;
$STATE = $_SESSION['ozpostOrigState'];
$PCODE = SHIPPING_ORIGIN_ZIP ;
$Z = $order->delivery['firstname'] . " " .  $order->delivery['lastname'] ;
//////////////////////////////

//// delete duplicate order numbers  (both files) //
//  ensure folder is read/writable
    $folder = DIR_FS_SQL_CACHE;
    $this->_changePerms($folder);

    $names = array("clickNsendDom.csv", "clickNsendInt.csv");

    foreach ($names as $filename) {
        if ($filename == "clickNsendDom.csv") {
            $testRef = 33;
        } else {
            $testRef = 42;
        }

        $rdata = file($folder . "/" . $filename);
        if ($rdata) {
            $ln = -1;
            foreach ($rdata as $line) {
                $ln++;

                $data = explode(",", $line);
                if (intval($data[$testRef]) == $ref) {
                    array_splice($rdata, $ln, 1);
                    $ln--; // delete
                }
            }
        } else {
            $rdata = array();
        }

        if (sizeof($rdata) == 0) {
            if(is_file($folder . "/" . $filename)) unlink($folder . "/" . $filename);
        } else {
            if (!(file_put_contents($folder . "/" . $filename, $rdata)))
                $err = 1;
        }
    }

//////////////////////////////////////

    if ($countryCode == "AU") {
$ownpackaging = 7 ;  //   seems to be the only one allowed!

$filename = "clickNsendDom.csv" ; 
 switch (substr($method, 0, 3)) {

            case "RPP";
                $ServiceCode = ($pweight <= 500) ? "PPS":"PP" ;
                break;

            case "EXP";
                $ServiceCode = ($pweight <= 500) ? "EPS":"EP" ;
               break;

            case "PLT";
                $ServiceCode = ($pweight <= 500) ? "EPPS":"EPP" ;
               break;
            case "REG";
                $ins = 1; $tracking = 1 ;
                  $ServiceCode = ($pweight <= 500) ? "PPS":"PP";
               break;

            case "PPS";
               $ownpackaging = 0 ;
               $irregular = 1 ;
                $methd = substr($method, 0, 4);

                if (($methd == "PPS3") && ($pweight <= 500)) $ServiceCode = "PPS"; 
                if (($methd == "PPS3") && ($pweight > 500))  $ServiceCode = "PP";  

                if (($methd == "PPS5") && ($pweight <= 500)) $ServiceCode = "PPS"; 
                if (($methd == "PPS5") && ($pweight > 500))  $ServiceCode =  "PP";  

                if (($methd == "PPSE") && ($pweight <= 500)) $ServiceCode = "EPPS"; 
                if (($methd == "PPSE") && ($pweight > 500))  $ServiceCode = "EPP"; 

                if (($methd == "PPSP") && ($pweight <= 500)) $ServiceCode = "PPS"; 
                if (($methd == "PPSP") && ($pweight > 500))  $ServiceCode = "PP";  
                break;

              case "EBA";
                $ownpackaging = 0 ;
                if ($method == "EBAY39712") $ServiceCode = "PPS" ; 
                if ($method == "EBAY39715") $ServiceCode = "PPS"; 
                if (($method == "EBAYBx1") && ($pweight <= 500))   $ServiceCode = "PPS" ; $plength = 22 ;$pwidth = 16.0 ;$pheight = 7.70 ;
                if (($method == "EBAYBx2")  && ($pweight <= 500))  $ServiceCode = "PPS" ; $plength = 31 ;$pwidth = 22.5 ;$pheight = 10.2 ;
                if (($method == "EBAYBx3")  && ($pweight <= 500))  $ServiceCode = "PPS" ; $plength = 43 ;$pwidth = 30.5 ;$pheight= 14.0 ;
                if (($method == "EBAYBx1") && ($pweight > 500))    $ServiceCode = "PP" ; $plength = 22 ;$pwidth = 16.0 ;$pheight = 7.70 ;
                if (($method == "EBAYBx2")  && ($pweight > 500))   $ServiceCode = "PP" ; $plength = 31 ;$pwidth = 22.5 ;$pheight = 10.2 ;
                if (($method == "EBAYBx3")  && ($pweight > 500))   $ServiceCode = "PP" ; $plength = 43 ;$pwidth = 30.5 ;$pheight = 14.0 ;
                break;
        }

if ($ServiceCode)   {
   $pweight = number_format($pweight / 1000 , 3) ; ///   xx.yyyKgs

$CSV = "\"".$order->delivery['company']."\",\"".  $order->delivery['firstname'] . " " .  $order->delivery['lastname']."\",\"".
                $order->customer['telephone']."\",\"".
                $order->customer['email_address']."\",\"".
                $order->delivery['street_address']."\",\"".$order->delivery['suburb']."\",,\"".
                $city ."\",".
                $state.",".
                $dpcode.",".
                $countryCode.",".
                $ServiceCode.",".$ownpackaging.",".
                $plength.",".$pwidth.",".$pheight.",".$pweight.",".
                $ins.",". $pvalue.",".
                "\"".$Description."\",\"".
                $FROM."\",\"".
                $COMPANY."\",".$PHONE.",,\"".$EMAIL."\",,".$ADDR.",,,\"".$SUB."\",".$STATE.",".$PCODE.",".$countryCode.",".
                $ref.",1,".
                $tracking.",".
                $irregular.",,,,,,,Y,Y,,"  ;
    }  // No service code (Domestic)

}  else {  // Not AU //

$type = 3; //   Merchandise
$Cat= 3; // 1 books, 2 clothing, 3 shoes, 4 fashion acc, 5 baby clothes, 6 other
$filename = "clickNsendInt.csv" ;

 switch (substr($method, 0, 3)) {

        case "ECI";
        case "EPI";
        case "RPI";
            $ServiceCode = substr($method, 0, 3);
            break;

        case "AIR";
            $ServiceCode = "AIRMAIL";
            break;

        case "PAT";
            $ServiceCode = "PTI";
            break;
}

if ($ServiceCode)   {
$pweight = number_format($pweight / 1000 , 3) ; ///   xx.yyyKgs
$CSV = "\"".$order->delivery['company']."\",\"".  $order->delivery['firstname'] . " " .  $order->delivery['lastname']."\",\"".
                $order->customer['telephone']."\",\"".
                $order->customer['email_address']."\",\"".
                $order->delivery['street_address']."\",\"".$order->delivery['suburb']."\",,\"".
                $city ."\",".
                $state.",".
                $dpcode.",".
                $countryCode.",".
                $ServiceCode.",".$type.",".
                $plength.",".$pwidth.",".$pheight.",".$pweight.",".$packageitems.",".
                $pvalue.",".$ins.",\"".$Description."\",".
                $Cat.",0,,\"".$Z."\",,AU,,,\"".
                $FROM."\",\"".
                $COMPANY."\",".$PHONE.",,\"".$EMAIL."\",,".$ADDR.",,,\"".$SUB."\",".$STATE.",".$PCODE.",AU,".
                $ref  ;

    } // No service code (International)
  }

  
        array_push($rdata, $CSV."\n")  ;
        if (!(file_put_contents($folder."/".$filename, $rdata,  FILE_APPEND)))  $err = 1 ;  

   }  // No address ///

$this->_restorePerms($folder) ;
}


private function _saveToCache($request, $data) {
   global $db ; 
   if ( MODULE_SHIPPING_OZPOST_DEBUG != "Yes") {
       $hash = md5($request) ;
       $cdata = addslashes(serialize($data)) ;
 $res =  $db->Execute("insert into " . TABLE_OZPOST_CACHE . " (cache_entry_name,cache_data) VALUES ('$hash', '$cdata') ; ");  
 }
}
private function _fetchFromCache($request) {
    global $db ;
if ( MODULE_SHIPPING_OZPOST_DEBUG != "Yes") {
          // 1st we expire all stale records - only if table exists  //
    $exp = 1 ; 
    if((MODULE_SHIPPING_OZPOST_EF == "None") || (MODULE_SHIPPING_OZPOST_LEADTIME > 0)) $exp = 8 ;
  
// $a =  intval(date("H")) ;|| (intval(date("H")) >= MODULE_SHIPPING_OZPOST_DEADLINE)
    $db->Execute('delete FROM `' . TABLE_OZPOST_CACHE . '` WHERE `cache_entry_created` < DATE_SUB(NOW(), INTERVAL '.$exp.' HOUR)')  ;   
    $hash = md5($request) ;
     $res = $db->Execute("select cache_data FROM " . TABLE_OZPOST_CACHE . " where cache_entry_name='$hash'") ;
    
     if ($res)  return unserialize(stripslashes($res->fields['cache_data']));  
} else { $db->Execute('delete FROM `' . TABLE_OZPOST_CACHE . '` WHERE 1')  ;   
}
 return FALSE ;
}

///////////////////////////////////////////

private function _getURL($server,$request) {
    
  $data = $this->_fetchFromCache($request) ;
  
  if(!$data) {
  
  global $messageStack ;
  $error1 = "" ;$error2 = "" ;$error0 = "" ;
    $time_start = microtime(true);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_VERBOSE, 0);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_USERAGENT, "[".PROJECT_VERSION_NAME. " ".PROJECT_VERSION_MAJOR.".".PROJECT_VERSION_MINOR." : " . $this->code. " v".$this->VERSION."] " . $_SERVER['SERVER_NAME'] );        //     curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, false);
        curl_setopt($ch, CURLOPT_TIMEOUT,10);

        if (CURL_PROXY_REQUIRED == 'True') {
            $proxy_tunnel_flag = (defined('CURL_PROXY_TUNNEL_FLAG') && strtoupper(CURL_PROXY_TUNNEL_FLAG) == 'FALSE') ? false : true;
            curl_setopt ($ch, CURLOPT_HTTPPROXYTUNNEL, $proxy_tunnel_flag);
            curl_setopt ($ch, CURLOPT_PROXYTYPE, CURLPROXY_HTTP);
            curl_setopt ($ch, CURLOPT_PROXY, CURL_PROXY_SERVER_DETAILS);
        }

   curl_setopt($ch, CURLOPT_URL,"svr1.".$server.$request); $data = curl_exec($ch); $error1 = curl_error($ch);

    if(($error1) || (!$data))   curl_setopt($ch, CURLOPT_URL,"svr2.".$server.$request);$data = curl_exec($ch);   $error2 = curl_error($ch);

   if (($error2)|| (!$data)) {
       curl_setopt($ch, CURLOPT_URL,"svr0.".$server.$request);  $data = curl_exec($ch);   $error0 = curl_error($ch);

    if (($error3)|| (!$data)) {
                 $messageStack->add_session('cURL communication ERROR: ' . $error1, 'error');
                 $messageStack->add_session('cURL communication ERROR: ' . $error2, 'error');
                 $messageStack->add_session('cURL communication ERROR: ' . $error3, 'error');
                 $data = '<error>Server#1 Error: ' . $error1 . '<br>Server#2 Error: ' . $error2 . '<br>Server#0 Error: ' . $error0 . '</error>' ;
        }
    }

    if (( MODULE_SHIPPING_OZPOST_DEBUG == "Yes")  &&  ($_GET['set'] != "shipping"))  {

        echo "<center><table border=1 width=95% ><tr><td>Server response time " . round(microtime(true) - $time_start,3) . "ms</td></tr>" ;
    }

 curl_close($ch);
 
 if ((substr($data, 0, 7)) != "<error>") $this->_saveToCache($request, $data) ; // don't cache server errors 
   
} // Got from cache //

 return $data ;
}

private function _createCachetable(){
    global $db ;
    
   $db->Execute("DROP TABLE IF EXISTS " . TABLE_OZPOST_CACHE ) ; 
   $db->Execute(" CREATE TABLE " . TABLE_OZPOST_CACHE . "(
                                `cache_entry_name` varchar(64) NOT NULL DEFAULT '', 
                                `cache_data` mediumblob,
                                `cache_entry_created` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
                                PRIMARY KEY (`cache_entry_name`))") ;
}

private function _changePerms($folder) {
 global $oldperms ;
 $oldperms  = NULL ;
  if(is_dir($folder)){
  $oldperms = substr(sprintf('%o', fileperms($folder)), -4) ;
  if ("$oldperms" < "0775") { 
       if (!chmod($folder, 0775)) $oldperms = NULL ; 
       } 
  }      
return $oldperms ;
}

private function _restorePerms($folder) {
  global $oldperms ;
  if ( isset($oldperms) && ("$oldperms" < "0775")) $r = chmod($folder , octdec($oldperms)) ;
}

private function _get_cache_folder($folder) {
        $cachefolder = DIR_FS_SQL_CACHE. "/ozpost/";
          if ($folder == DIR_FS_ADMIN) { 
            $elements = explode("/", $folder);
            $cachefolder .= $elements[sizeof($elements) - 2] . "/";
        }
return $cachefolder ;
}

private function writeTempFile($folder, $subfolder, $filename, $data) {
$err = false;
        
       $oldperm = $this->_changePerms(DIR_FS_SQL_CACHE) ;
       $cachefolder = $this->_get_cache_folder($folder) ; 
       $myFolder = $cachefolder . $subfolder;

        if (!is_dir($myFolder)) {
            if (!mkdir($myFolder, 0775, true))  $err = true; }

        if (!$err) { // no error, write file 
            $file = $myFolder . $filename;
            if (!(file_put_contents($file, $data)))  $err = true; }
            
if ( isset($oldperm) && ("$oldperm" < "0775")) $t = chmod(DIR_FS_SQL_CACHE , octdec($oldperm)) ;

return $err;
 }

////////////////////////////////////////////////////////////////
function check() {
  global $db, $messageStack, $Ozfiles, $updavail;

  $updavail = NULL;
      
        if (!isset($this->_check)) {
                        
            $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_OZPOST_STATUS'");
            $this->_check = $check_query->RecordCount();
              
              // version check / network check //
                if (MODULE_SHIPPING_OZPOST_STATUS == "True") {
                  //  JavaScript //  
                                  echo "<script type=\"text/javascript\">
                                    function updateModule(val, text) {
                                       if (window.confirm(text)) { window.location = 'modules.php?set=shipping&module=ozpost&action=edit&update=1';
                                        } else { document.getElementById('updater').value = val+\" (postponed)\" ; } 
                                    }
                                </script> " ;    
                                  
                $res =  $db->Execute("SELECT COUNT(*) FROM information_schema.tables WHERE table_schema = '" . DB_DATABASE . "' AND table_name = '" . TABLE_OZPOST_CACHE . "';") ; 
                if ($res->fields['COUNT(*)'] == 0)  $this->_createCachetable() ;
          
                $result = $this->_getURL($this->SERVER, "/postage.php?flags=get_latest_client_version");
 // $result = "V3.3.6" ;
                if ((substr($result, 0, 1) == "V") && ($result > "V$this->VERSION")) {
                    $updavail = substr($result, 1);
                    $messg = "OzPost V$updavail update available";
                } else {

                    if ($this->VERSION != MODULE_SHIPPING_OZPOST_DB_VERS) {
                        $updavail = $this->VERSION;
                        $messg = "Database and File versions differ (V" . MODULE_SHIPPING_OZPOST_DB_VERS . " / V" . $this->VERSION . ")";
                    }
                }
                if($updavail) echo "<input type=\"button\" name=\"updater\" value=\"$messg\" id=\"updater\" onClick=\"updateModule('$messg', 'Upgrade now?') \" />" ;
                     
           if(($_REQUEST['update'] == "1") && ($_REQUEST['action'] == "edit")  && ($_REQUEST['module'] == "ozpost"))  $this->update($updavail) ; 
  

                    if(SHIPPING_ORIGIN_ZIP != "") {
                            if(MODULE_SHIPPING_OZPOST_ORIGIN_ZIP == "")  $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = \"".SHIPPING_ORIGIN_ZIP . "\" where configuration_key = \"MODULE_SHIPPING_OZPOST_ORIGIN_ZIP\"");
                            
                        $result = $this->_getURL($this->SERVER, "/postage.php?flags=expires&host=$this->HOST&storecode=" . SHIPPING_ORIGIN_ZIP);
                        $days = intval($result);

                         $res = $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = \"$days\" where configuration_key = \"MODULE_SHIPPING_OZPOST_EXPIRE\"");
                        }  
                        if (MODULE_SHIPPING_OZPOST_TYPE_LETTERS == "--none--") {   // No letters, then don't hide parcels //
                         $res = $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = \"No\" where configuration_key = \"MODULE_SHIPPING_OZPOST_HIDE_PARCELD\"");
                         $res = $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = \"No\" where configuration_key = \"MODULE_SHIPPING_OZPOST_HIDE_PARCELO\"");
                        }
                        if (MODULE_SHIPPING_OZPOST_TYPE_APS == "--none--") {   // No satchels, then don't hide parcels //
                         $res = $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = \"No\" where configuration_key = \"MODULE_SHIPPING_OZPOST_HIDE_PARCEL2\"");
                        }

     }  // end MODULE_SHIPPING_OZPOST_STATUS == "True"
 } //  end !isset($this->_check

 return $this->_check;
}

 private function update($updavail) {
global $messageStack, $auto, $db ; //, $updavail;

if($updavail != $this->VERSION) {

$t = $db->Execute('delete FROM `' . TABLE_OZPOST_CACHE . '` WHERE 1')  ;   
  $vers = preg_replace("/[^0-9]/", "", $updavail);    //  numbers only
                            $filename = "ozpost_zen." . $vers;  // the update filename
                            $result = $this->_getURL($this->SERVER, "/updates/" . $filename);// get it
                              if ($result != "") {

                                $folder = DIR_FS_CATALOG_MODULES . "shipping/";
                                $this->_changePerms($folder);

                                $myFile = $folder . $filename;
                                if (file_put_contents($myFile, $result)) { //   save and check
                                    if ((strpos($result, "// Zencart"))) {   // check for valid data in file
                                        //  make a backup of the original file
                                        $verso = preg_replace("/[^0-9]/", "", $this->VERSION);    //  numbers only
                                        if (rename(ME, $folder . "ozpost" . $verso)) {
                                            //  copy new file to old
                                            if (rename($myFile, ME)) {
                                                $messageStack->add_session('The ozpost shipping module has been updated. Please check your settings.', 'caution');
                                                $messageStack->add_session('Your previously installed module has been saved as ozpost' . $verso, 'caution');
                                                // updated OK - Display changes  
                                                 $f = file(ME) ;       
                                                    foreach($f as $line) {
                                                    if (strstr($line, "\$Id: ozpost.php,V".$this->VERSION)) {
                                                                        $messageStack->add_session($line,'success') ;    
                                                                        $line = next($f) ;
                                                                          while   (!strstr($line, "*/"))  {  $messageStack->add_session($line,'success') ;   
                                                                                                            $line = next($f) ; } 
                                                                                                            break ; }
                                                        }
                                                     $this->VERSION = $updavail;   
                                            } else { $messageStack->add_session('There was an error renaming the Update file. Update Aborted.', 'error');
                                                     rename($folder."ozpost".$verso, ME);  } // restore the original
                                        } else { $messageStack->add_session('There was an error renaming the original file. Update Aborted.', 'error'); }
                                    } else { $messageStack->add_session('There was an error in the file downloaded. Update Aborted.', 'error'); }
                                } else { $messageStack->add_session('There was an error saving the Update File. Update Aborted.', 'error'); }
                            } else {  $messageStack->add_session('No data returned from the server. Update Aborted', 'error');  }

                            $this->_restorePerms($folder);    
    
}
   if($this->VERSION == $updavail) {                     
 
       $auto = 1 ;
       $this->remove() ;
        
        // Delete obsolete ozpost TPL file
    $template = $GLOBALS['template_dir'];
    $folder = DIR_FS_CATALOG_TEMPLATES . $template . "/templates/";
    $this->_changePerms($folder);
    $myFile = $folder . "tpl_modules_shipping_estimator.php";
    if (file_exists($myFile)) {
        $section = file_get_contents($myFile, NULL, NULL, 0, 50);
        if ((strpos($section, " // ozpost template v3")) && ( MODULE_SHIPPING_OZPOST_UPDATES == "Auto"))
            unlink($myFile);
    }
    $this->_restorePerms($folder);
     $this->install() ;
 
        unset($auto) ;
          $messageStack->add_session('The ozpost module has been updated. Please CHECK YOUR SETTINGS and click the UPDATE button at the bottom of this page.' ,'caution') ;

     } // had error 
 foreach($_SESSION['messageToStack'] as $info) {
    $style = "<div style='color:black;'>" ;
     if ($info['type'] == 'error')   { $style = "<div style='background-color: #FFB3B5;'>" ; }  
     if ($info['type'] == 'caution') { $style = "<div style='background-color: #FFFF00;'>" ; }  
     if ($info['type'] == 'success') { $style = "<div style='background-color: #D4FFBD;'>" ; }  
     
     echo $style.$info['text']."</div>" ;   
 }
unset($_REQUEST['update']) ;
unset($_SESSION['messageToStack']) ;
 }  

////////////////////////////////////////////////////////////////////////////
function install() {
    global $db, $messageStack, $Ozfiles, $updavail ;
/////////////////////////  create tables if they don't already exist //////
   $installed = 0 ; $name = "" ;
   $query = "SHOW COLUMNS FROM  " .  TABLE_PRODUCTS ;
    $result = mysql_query($query) ;
     while (list ($name) = mysql_fetch_row ($result))
        if($name == "products_length") $installed = 1 ;

    if($installed != 1)  $db->Execute("ALTER TABLE " .TABLE_PRODUCTS. " ADD `products_length` FLOAT(6,2) NULL AFTER `products_weight`, ADD `products_height` FLOAT(6,2) NULL AFTER `products_length`, ADD `products_width` FLOAT(6,2) NULL AFTER `products_height`" ) ;

     // Drop & recreate cache table
   $this->_createCachetable() ;
   
//            if(defined('TABLE_ADMIN_MENUS')) {   // Add new menu for V1.5. - Decided it was better back in Customers menu
//     $result = mysql_query ("SELECT menu_key FROM " .  TABLE_ADMIN_MENUS . " WHERE menu_key = \"ClickNsend\"") ;
//       $test =  mysql_fetch_row ($result) ;
//      if(!$test) {  $db->Execute("INSERT INTO ". TABLE_ADMIN_MENUS. " (`menu_key` , `language_key` , `sort_order`) VALUES ('ClickNsend', 'BOX_HEADING_CLICKNSEND', '5' )" ) ; }
//}
  ////////  PHP Version Test ///
    if (substr(PHP_VERSION, 0,1) <= "4")  {  // 4
        $messageStack->add_session('Installation FAILED. Ozpost requres PHP5.1 or higher. '); ;
       echo "This module requres PHP5 or higher to work. Most Webhosts will support this.<br>Installation will NOT continue.<br>Press your back-page to continue " ;
       exit ;
        }

    // cURL & Connectivity test //
    $suburb = "" ;$postcode = "" ;
    $result = $this->_getURL($this->SERVER, "/postage.php?flags=get_latest_client_version") ;
      if (substr($result, 0, 1) != "V" )  {    $messageStack->add_session('Network Connectivity test FAILED<br>Is cURL installed?');
        echo  'Network Connectivity test FAILED<br>Is cURL installed?' ;
        }  else {
         
            if (SHIPPING_ORIGIN_ZIP != "") { 
            $postcode =  SHIPPING_ORIGIN_ZIP  ;
            $suburb = urldecode($this->_getURL($this->SERVER, "/postage.php?flags=get_suburb&fromcode=".$postcode)) ;
            }
}

//  Kgs or Gms ? (if not set use bestguess) 
$res = $db->Execute("select configuration_value from ". TABLE_CONFIGURATION . " WHERE configuration_key = 'bakMODULE_SHIPPING_OZPOST_WEIGHT_FORMAT' limit 1") ; 
$weight_factor = $res->fields['configuration_value'] ;

if(!$weight_factor) {
$weight_factor = "gms" ;
$res = $db->Execute("select products_weight from ". TABLE_PRODUCTS . " WHERE products_weight LIKE '%\.%' limit 1") ; 
if($res->fields['products_weight']) $weight_factor = "kgs"  ;
}

// All tests passed - continue with installation
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('<a target=_blank href=http://shop.vcsweb.com/index.php?main_page=product_info&cPath=43&products_id=207>Subscription Days remaining (click to renew)</a>','MODULE_SHIPPING_OZPOST_EXPIRE', '', 'Days until server licence expires (Read only)', '6', '1', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Enabled','MODULE_SHIPPING_OZPOST_STATUS', 'True', 'Enable this Module', '6', '1', 'ozpost::ozp_cfg_select_option(array(\'True\', \'False\'), ', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function,  date_added)
                  values ('<hr>Letters (and small parcels@letter rates)', 'MODULE_SHIPPING_OZPOST_TYPE_LETTERS',
                            'Aust Standard, Aust Registered, Overseas Standard',
                            'Select the methods you wish to allow',
                            '6','3',
                            'zen_cfg_select_multioption(array(\'Aust Standard\',\'Aust Registered\',\'Aust Insured\',\'Aust Express\',
                                                             \'Overseas Standard\',\'Overseas Registered\',\'Overseas Express\'), ',
                            now())"  ) ;

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function,  date_added)
                  values ('<hr>Australia Post Parcels - Australia', 'MODULE_SHIPPING_OZPOST_TYPE_APP',
                            'Regular, Registered, Insured',
                            'Select the methods you wish to allow',
                            '6','3',
                            'zen_cfg_select_multioption(array(\'Regular\',\'Registered\',\'Insured\',\'Express\',
                            \'Platinum\',\'Insured Platinum\',
                            \'Cash on Delivery\'), ',
                            now())" ) ;

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function, date_added)
                    values ('<hr>ClickNsend Prepaid (eBay specials)', 'MODULE_SHIPPING_OZPOST_TYPE_EBAY',
                            ' ',
                            'Select the methods you wish to allow. You dont have to be an eBay user to use these.',
                            '6','4',
                            'zen_cfg_select_multioption(array(\'500gm Satchel\',\'3kg Satchel\',\'Small box 15kg (A5)\',\'Medium box 15kg (A4)\',\'Large box 15kg (A3)\'), ',
                            now())" ) ;

        $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value = \"2\" where configuration_key = \"SHOW_SHIPPING_ESTIMATOR_BUTTON\"" );

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function,  date_added)
                  values ('<hr>Australia Post PrePaid Satchels', 'MODULE_SHIPPING_OZPOST_TYPE_APS',
                            '500gm Parcel Post+, 3Kg Parcel Post+, 5Kg Parcel Post+',
                            'Select the methods you wish to allow',
                            '6','3',
                            'zen_cfg_select_multioption(array(
                            \'500gm Parcel Post+\',\'500gm Parcel Post+ Registered\',\'500gm Parcel Post+ Insured\',
                            \'3Kg Parcel Post+\',\'3Kg Parcel Post+ Registered\',\'3Kg Parcel Post+ Insured\',
                            \'5Kg Parcel Post+\',\'5Kg Parcel Post+ Registered\',\'5Kg Parcel Post+ Insured\',
                            \'500gm Express\',\'3Kg Express\',\'3Kg XL Express\',\'5Kg Express\',\'5kg XL Express\',
                            \'500gm Platinum\',\'500gm Platinum Insured\',\'3Kg Platinum\',\'3Kg Platinum Insured\'), ',
                            now())" ) ;

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function, date_added)
                    values ('<hr><a href=http://www.fastway.com.au/>FastWay Couriers</a>', 'MODULE_SHIPPING_OZPOST_TYPE_FW',
                            ' ',
                            'Select the methods you wish to allow',
                            '6','4',
                            'zen_cfg_select_multioption(array(\'Red Label\',\'Orange Label\',\'Green Label\',
                            \'White Label\',\'Grey Label\',\'Brown Label\',\'Black Label\',
                            \'Blue Label\',\'Yellow Label\',\'Lime Label\',\'Pink Label\',
                            \'A5 Satchel (1Kg)\',\'A3 Satchel (local)\',\'A3 Satchel (3Kg)\',\'A2 Satchel (5Kg)\'), ',
                            now())"  ) ;

         $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function, date_added)
                    values ('<hr><a href=https://www.tntexpress.com.au/interaction/asps/login.asp>TNT Australia</a>', 'MODULE_SHIPPING_OZPOST_TYPE_TNT',
                            ' ',
                            'Select the methods you wish to allow',
                            '6','4',
                            'zen_cfg_select_multioption(array(
                            \'Road Express\',
                            \'Overnight Express by 9:00am\',
                            \'Overnight Express by 10:00am\',
                            \'Overnight Express by 12:00pm\',
                            \'Overnight Express by 5:00pm\',
                            \'Technology Express - Sensitive Express\',  ), ',
                            now())" ) ;

         $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function, date_added)
                    values ('<hr><a href=http://Transdirect.com.au>Transdirect.com.au</a>', 'MODULE_SHIPPING_OZPOST_TYPE_TRD',
                            ' ',
                            'Select the methods you wish to allow',
                            '6','4',
                            'zen_cfg_select_multioption(array(
                            \'Transdirect Road Express\',
                            \'Transdirect Airfreight - Overnight\',
                            \'Transdirect Airfreight - 2 Day Economy\',
                            \'Transdirect Airfreight - 3 Day Offpeak\',
                            \'Transdirect Airfreight - Next Flight\',  ), ',
                            now())" ) ;

           $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function, date_added)
                    values ('<hr><a href=http://e-go.com.au>e-go.com.au</a>', 'MODULE_SHIPPING_OZPOST_TYPE_EGO',
                            ' ',
                            'Select the methods you wish to allow',
                            '6','4',
                            'zen_cfg_select_multioption(array(
                            \'e-go.com.au\',
                            \'Insured e-go.com.au\' ), ',
                            now())" ) ;

$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
               configuration_group_id, sort_order, set_function, date_added)
                        values ('<hr>Australia Post Overseas Parcels', 'MODULE_SHIPPING_OZPOST_TYPE_APOS',
                        'Air, Registered Air, Insured Air',
                        'You get the idea..',
                        '6','4',
                        'zen_cfg_select_multioption(array(\'Air\', \'Registered Air\', \'Insured Air\',
                        \'Registered Air 500gm Prepaid bag\',\'Registered Air 1kg Prepaid bag\',
                        \'Pack and Track\',
                        \'Express Parcel International (EPI)\',\'Insured Express Parcel International (EPI)\',
                        \'EPI 2Kg Prepaid Satchel\',\'EPI 3Kg Prepaid Satchel\',\'EPI 5Kg Prepaid Box\',
                        \'EPI 10Kg Prepaid Box\',\'EPI 20Kg Prepaid Box\',
                        \'Sea\',\'Insured Sea\',
                        \'Express Courier International Documents (ECI)\',
                        \'Express Courier International Documents Insured (ECI)\',
                        \'Express Courier International Merchandise (ECI)\',
                        \'Express Courier International Merchandise Insured (ECI)\',
                        \'ECI 500gm Prepaid Satchel\',\'ECI 1Kg Prepaid Satchel\',\'ECI 2Kg Prepaid Satchel\',
                        \'ECI 3Kg Prepaid Satchel\',\'ECI 5Kg Prepaid Box\',\'ECI 10Kg Prepaid Box\',\'ECI 20Kg Prepaid Box\'),',
                        now())" );

     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description,
                                                            configuration_group_id, sort_order, set_function, date_added)
                    values ('<hr>Mail Days', 'MODULE_SHIPPING_OZPOST_MAILDAYS',
                            'Monday, Tuesday, Wednesday, Thursday, Friday',
                            'Select the days you mail',
                            '6','4',
                            'zen_cfg_select_multioption(array(\'Monday\',\'Tuesday\',\'Wednesday\',\'Thursday\',\'Friday\',\'Saturday\' ,\'Sunday\'), ',
                            now())"  ) ;


    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Estimated Delivery Format', 'MODULE_SHIPPING_OZPOST_EF', 'Date', 'Try both, or None, see which you prefer', '6', '35', 'ozpost::ozp_cfg_select_option(array(\'None\', \'Date\', \'Days\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Deadline \(hour\)', 'MODULE_SHIPPING_OZPOST_DEADLINE', '10', 'Deadline for same day mailings<br>10= 10am, 11=11am, 12=noon, 13=1pm, etc<br>This uses the store localtime based on the postcode', '6', '24', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Shipping from PostCode', 'MODULE_SHIPPING_OZPOST_ORIGIN_ZIP', '$postcode', 'What postcode do you ship from?', '7', '2', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Shipping from Suburb', 'MODULE_SHIPPING_OZPOST_ORIGIN_SUBURB', '$suburb', 'What suburb do you ship from?', '7', '2', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Hide parcel rates if letter sized \(domestic\)? ', 'MODULE_SHIPPING_OZPOST_HIDE_PARCELD', 'No', 'If the parcel/items are letter sized would you like to hide the parcel postage rates? \(domestic shipments\)', '6', '7', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Hide parcel rates if letter sized \(overseas\)? ', 'MODULE_SHIPPING_OZPOST_HIDE_PARCELO', 'No', 'If the parcel/items are letter sized would you like to hide the parcel postage rates? \(overseas shipments\)', '6', '7', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Hide parcel rates if Satchel sized ? ', 'MODULE_SHIPPING_OZPOST_HIDE_PARCEL2', 'No', 'If the items will fit into a satchel would you like to hide the parcel postage rates? </br>Note: Has no effect if debug is enabled</br>', '6', '7', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Hide Courier rates if Australia Post can handle it? ', 'MODULE_SHIPPING_OZPOST_HIDE_COURIER', 'No', 'If the items can be sent by Australia Post would you like to hide the courier rates? </br>Note: Has no effect if debug is enabled</br>', '6', '7', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
     
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, 
        configuration_value, configuration_description, configuration_group_id, sort_order,
        set_function, date_added) VALUES ('FastWay Franchise', 'MODULE_SHIPPING_OZPOST_FWF', 
        'Select Franchise to enable', '' , '6', '8',
        'ozpost::ozp_cfg_select_drop_down(array(
                     array(\'id\'=>\'disabled\' , \'text\'=>\'disabled\'),
                     array(\'id\'=>\'ADL\' , \'text\'=>\'Adelaide\'),
                     array(\'id\'=>\'ALB\' , \'text\'=>\'Albury\'),
                     array(\'id\'=>\'BEN\' , \'text\'=>\'Bendigo\'),
                     array(\'id\'=>\'BRI\' , \'text\'=>\'Brisbane\'),
                     array(\'id\'=>\'CNS\' , \'text\'=>\'Cairns\'),
                     array(\'id\'=>\'CBR\' , \'text\'=>\'Canberra\'),
                     array(\'id\'=>\'CAP\' , \'text\'=>\'Capricorn Coast\'),
                     array(\'id\'=>\'CCT\' , \'text\'=>\'Central Coast\'),
                     array(\'id\'=>\'CFS\' , \'text\'=>\'Coffs Harbour\'),
                     array(\'id\'=>\'GEE\' , \'text\'=>\'Geelong\'),
                     array(\'id\'=>\'GLD\' , \'text\'=>\'Gold Coast\'),
                     array(\'id\'=>\'TAS\' , \'text\'=>\'Hobart\'),
                     array(\'id\'=>\'LAU\' , \'text\'=>\'Launceston\'),
                     array(\'id\'=>\'MKY\' , \'text\'=>\'Mackay\'),
                     array(\'id\'=>\'MEL\' , \'text\'=>\'Melbourne\'),
                     array(\'id\'=>\'NEW\' , \'text\'=>\'Newcastle\'),
                     array(\'id\'=>\'NTH\' , \'text\'=>\'Northern Rivers\'),
                     array(\'id\'=>\'PER\' , \'text\'=>\'Perth\'),
                     array(\'id\'=>\'PQQ\' , \'text\'=>\'Port Macquarie\'),
                     array(\'id\'=>\'SUN\' , \'text\'=>\'Sunshine Coast\'),
                     array(\'id\'=>\'SYD\' , \'text\'=>\'Sydney\'),
                     array(\'id\'=>\'TOO\' , \'text\'=>\'Toowoomba\'),
                     array(\'id\'=>\'TVL\' , \'text\'=>\'Townsville\'),
                     array(\'id\'=>\'WDB\' , \'text\'=>\'Wide Bay\'),
                     array(\'id\'=>\'WOL\' , \'text\'=>\'Wollongong\')),',
                            now())" ) ;

    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('FastWay frequent user?', 'MODULE_SHIPPING_OZPOST_FW_FREQ', 'No', 'Frequent users have lower rates, but require a minimum monthly spend.', '6', '9', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TNT Account Number', 'MODULE_SHIPPING_OZPOST_TNT_ACCT', '', 'A valid TNT account number is required for TNT quotes.<br>Sign up at: https://www.tntexpress.com.au/', '6', '10', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TNT username', 'MODULE_SHIPPING_OZPOST_TNT_USER', '', 'A valid TNT username is required for TNT quotes', '6', '11', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TNT password', 'MODULE_SHIPPING_OZPOST_TNT_PSWD', '', 'A valid TNT password is required for TNT quotes', '6', '12', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('<hr>Handling Fee - Letters', 'MODULE_SHIPPING_OZPOST_LET_HANDLING', '2.00', 'Handling Fee for letters.', '6', '13', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Regular parcels', 'MODULE_SHIPPING_OZPOST_RPP_HANDLING', '5.00', 'Handling Fee Regular parcels (keep in mind that handling fees need to include packaging material)', '6', '14', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Prepaid Satchels', 'MODULE_SHIPPING_OZPOST_PPS_HANDLING', '4.00', 'Handling Fee for Prepaid Satchels.', '6', '15', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - eBay Satchels', 'MODULE_SHIPPING_OZPOST_EBAYS_HANDLING', '0.00', 'Handling Fee for eBay Satchels.', '6', '15', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - eBay Boxes', 'MODULE_SHIPPING_OZPOST_EBAYB_HANDLING', '0.00', 'Handling Fee for eBay boxes.<br>Tip: Quotes are based on minimum purchase costs. If you buy in larger quantities and wish to pass the discount on you can enter negative values here. ', '6', '15', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Prepaid Satchels - Express', 'MODULE_SHIPPING_OZPOST_PPSE_HANDLING', '5.00', 'Handling Fee for Prepaid Express Satchels.', '6', '16', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Prepaid Satchels - Platinum', 'MODULE_SHIPPING_OZPOST_PPSP_HANDLING', '6.00', 'Handling Fee for Prepaid Platinum Satchels.', '6', '16', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Express parcels', 'MODULE_SHIPPING_OZPOST_EXP_HANDLING', '5.00', 'Handling Fee Express parcels - This is <strong>in addition</strong> to other handling fees (excluding Express and Prepaid satchels).', '6', '17', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Platinum parcels', 'MODULE_SHIPPING_OZPOST_PLT_HANDLING', '6.00', 'Handling Fee Platinum parcels - This is <strong>in addition</strong> to other handling fees (excluding Prepaid satchels).', '6', '17', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - COD', 'MODULE_SHIPPING_OZPOST_COD_HANDLING', '12.00', 'Handling Fee for COD deliveries', '6', '18', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Overseas parcels', 'MODULE_SHIPPING_OZPOST_INT_HANDLING', '8.00', 'Handling Fee for overseas parcels (These may require additional packaging).', '6', '19', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - ECI Documents', 'MODULE_SHIPPING_OZPOST_ECID_HANDLING', '10.00', 'Handling Fee - ECI Documents.', '6', '20', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - ECI Merchandise', 'MODULE_SHIPPING_OZPOST_ECIM_HANDLING', '10.00', 'Handling Fee - ECI Merchandise.', '6', '21', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - EPI Merchandise', 'MODULE_SHIPPING_OZPOST_EPI_HANDLING', '10.00', 'Handling Fee - EPI Merchandise.', '6', '21', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - FastWay Labels', 'MODULE_SHIPPING_OZPOST_FWL_HANDLING', '1.00', 'Handling Fee - FastWay Labels', '6', '22', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - FastWay Satchels', 'MODULE_SHIPPING_OZPOST_FWS_HANDLING', '0.50', 'Handling Fee - FastWay Satchels', '6', '23', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - TNT Merchandise', 'MODULE_SHIPPING_OZPOST_TNT_HANDLING', '5.00', 'Handling Fee - TNT Merchandise.', '6', '24', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - TransDirect', 'MODULE_SHIPPING_OZPOST_TRD_HANDLING', '5.00', 'Handling Fee - TransDirect.', '6', '24', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - EGO', 'MODULE_SHIPPING_OZPOST_EGO_HANDLING', '5.00', 'Handling Fee - EGO.', '6', '24', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Registered and/or Insured parcels \& letters', 'MODULE_SHIPPING_OZPOST_RI_HANDLING', '2.00', 'Handling Fee for Registered and/or Insured Parcels & Letters - This is <strong>in addition</strong> to other handling fees.', '6', '25', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Include USA Security surcharge.', 'MODULE_SHIPPING_OZPOST_SURCHARGE', 'Yes', 'Disable at your own risk.', '6', '87', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Hide Handling Fees?', 'MODULE_SHIPPING_OZPOST_HIDE_HANDLING', 'No', 'The handling fees are still in the total shipping cost but the Handling Fee is not itemised on the invoice.', '6', '26', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('<hr>Fixed Cost', 'MODULE_SHIPPING_OZPOST_COST_ON_ERROR', '25.00,99.99', 'These rates will be used according to the <strong>Fixed cost Type</strong>. They are only shown when no other methods are available, eg: server offline, network glitches, etc. The First value is for Australian delivery. The second value for Overseas delivery.</br> A value of zero will disable the module when all else fails.', '6', '27', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('<hr>Default ITEM Dimensions', 'MODULE_SHIPPING_OZPOST_DIMS', '29,25,2.5', 'Default ITEM dimensions (in cm). Three comma seperated values (eg 29,24,2.5 = 29cm x 24cm x 2.5cm). These are used if the dimensions of individual products are not set', '6', '28', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Fixed cost Type', 'MODULE_SHIPPING_OZPOST_COST_ON_ERROR_TYPE', 'Flat Rate', 'Please select', '6', '29', 'ozpost::ozp_cfg_select_option(array(\'Flat Rate\', \'Cost per Kg\', \'Cost per Item\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Parcel Weight format', 'MODULE_SHIPPING_OZPOST_WEIGHT_FORMAT', '$weight_factor', 'Are your store items weighted by grams or Kilos? (required so that we can pass the correct weight to the server).', '6', '30', 'ozpost::ozp_cfg_select_option(array(\'gms\', \'kgs\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Tare Weight (%).', 'MODULE_SHIPPING_OZPOST_TARE', '10', 'Add this percentage of the items total weight as the tare weight. 10% seems to work pretty well. (This setting is ignored if Use Core Weight is set to YES.).', '6', '31', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Tare Dimensions', 'MODULE_SHIPPING_OZPOST_DIMTARE', '2,2,2', 'Package Tare dimensions (in mm). Three comma seperated values (eg 2,2,2 = 2mm x 2mm x 2mm).', '6', '33', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('<hr>Icons type', 'MODULE_SHIPPING_OZPOST_ICONS', 'jpg', 'Different icon types for different needs. What\'s yours\?', '6', '35', 'ozpost::ozp_cfg_select_option(array(\'none\', \'jpg\', \'png\', \'gif\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('<hr>Enable Debug?', 'MODULE_SHIPPING_OZPOST_DEBUG', 'No', 'See how parcels are created from individual items.</br>Shows all methods returned by the server, including possible errors. <strong>ENABLE this to help find problems</strong>', '6', '40', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('<hr>Show error messages?', 'MODULE_SHIPPING_OZPOST_MSG', 'Yes', 'Shows errors, such as overweight, invalid dimensions, etc.', '6', '40', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Lead time \(days\).', 'MODULE_SHIPPING_OZPOST_LEADTIME', '0', 'Add this number of days before estimating delivery times. Useful if you don\'t carry stock in hand and need \'x\' days to source before estimating delivery times/dates.<br>Setting this \>0 makes a mockery of overnight delivery estimates, which should probably be disabled.', '6', '45', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('<hr>Use Core Weight.', 'MODULE_SHIPPING_OZPOST_CORE_WEIGHT', 'No', 'Set this to YES if you wish your parcels to be split by weight as set in the Shipping/Packaging section. <strong><font color=red>Warning: Setting this to YES may cause parcels to be split in ways that are physically impossible</font></strong>.', '6', '70', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Restrain Dimensions.', 'MODULE_SHIPPING_OZPOST_RESTRAIN_DIMS', 'No', 'Set this to YES if you wish to restrain the parcel dimensions to within allowable limits.  <strong><font color=red>Warning: Setting this to YES may produce quotes for parcels that are too large for the carrier(s) to handle.</font></strong>', '6', '75', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ',now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('<hr>Sort order of display.', 'MODULE_SHIPPING_OZPOST_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '85', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('<hr>Enable ClickNsend CSV.', 'MODULE_SHIPPING_OZPOST_CSV', 'No', 'When enabled suitable parcels have mail details exported to a CSV file suitable to import into Australia Posts website.', '6', '87', 'ozpost::ozp_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_SHIPPING_OZPOST_TAX_CLASS', '0', 'Set Tax class or -none- if not registered for GST.', '6', '90', 'zen_get_tax_class_title', 'zen_cfg_pull_down_tax_classes(', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('EmailFlag', 'MODULE_SHIPPING_OZPOST_EMAIL_FLAG', '0', 'Internal use only (prevents multiple emails being sent for subscription reminders)', '6', '90', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Remove button Action', 'MODULE_SHIPPING_OZPOST_REMOVE_ACTION', 'Upgrade', 'Setting this to Upgrade will retain your current data during the remove/install process.', '6', '26', 'ozpost::ozp_cfg_select_option(array(\'Upgrade\', \'Complete removal\'), ', now())");
//     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Update method', 'MODULE_SHIPPING_OZPOST_UPDATES', 'Auto', 'This will attempt to download and install program updates when available. Most errors are caused by insufficient server permissions', '6', '26', 'ozpost::ozp_cfg_select_option(array(\'Manual\', \'Auto\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('DBversion', 'MODULE_SHIPPING_OZPOST_DB_VERS', '$this->VERSION', 'Internal use only. Used to ensure databases and files remain syncronised', '6', '90', now())");

// restore backup data    (if exists)
    $query = "select configuration_key as 'key', configuration_value from " . TABLE_CONFIGURATION . " where configuration_key like 'bakMODULE_SHIPPING_OZPOST_%' " ;
   $row = $db->Execute($query) ;

   while (!$row->EOF) {
       $key = substr($row->fields['key'],3)  ;
       $value = $row->fields['configuration_value'] ;

        // $zenSelect = addslashes(str_replace("zen_cfg_select_multioption","ozpost::cfg_select_multioption",$row->fields['set_function'])) ;
        // $query2  =  "update  " . TABLE_CONFIGURATION . " set configuration_value = '$value', set_function = '$zenSelect'  where configuration_key = '$key' " ;
        // $db->Execute($query2);

        $result = $db->Execute("update  " . TABLE_CONFIGURATION . " set configuration_value = '$value' where configuration_key = '$key' ");
       $row->MoveNext();
  }  // endwhile

  // keep the version up to date ('cos the new/current would have beenoverwritten with the restore)
   $db->Execute("update  " . TABLE_CONFIGURATION . " set configuration_value = '$this->VERSION' where configuration_key like 'MODULE_SHIPPING_OZPOST_DB_VERS' ");

  // delete for next time  (shouldn't need this, but man removal of DB data will leave em lying around causing re-install problems
    $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key like 'bakMODULE_SHIPPING_OZPOST_%' ");

// Click N Send files
$clickSendheader = "<?php
// +----------------------------------------------------------------------+
// |               (c) Rod Gasson / VCSWEB 2012                           |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+
// This file is dynamically created by ozpost.php. Changes will be lost.
" ;

$premodMsgA = "The file <strong>(" ;
$premodMsgB = ") </strong> has already been modified. This alert can be ignored " ;

 ///   modify  admin/includes/languages/english/product.php  (Ozfiles[4]) 
 $file = $Ozfiles[4][0] . $Ozfiles[4][1] . $Ozfiles[4][2];
        $data = NULL;
        $errors = 0;

        if ($rdata = file($file)) {
            if (count(preg_grep("/TEXT_PRODUCTS_HEIGHT/", $rdata)) <= 0) {

                $ln = 0;
                foreach ($rdata as $line) {
                    if (strstr($line, "define('TEXT_PRODUCTS_WEIGHT',")) {
                        $data = str_replace("Product Weight:", "Product Weight (" . $weight_factor . "):", $line);
                        $data .= "define('TEXT_PRODUCTS_HEIGHT',  'Product Height (cm):') ;\n";
                        $data.= "define('TEXT_PRODUCTS_WIDTH',   'Product Width  (cm):') ;\n";
                        $data .= "define('TEXT_PRODUCTS_LENGTH',  'Product Length (cm):') ;\n";
                        array_splice($rdata, $ln, 1, (array) $data); // splice 
                    }
                    $ln++;
                }
            } else {
                $messageStack->add_session($premodMsgA . "$file" . $premodMsgB, 'warning');
            } // premodded  

            if ($this->writeTempFile($Ozfiles[4][0], $Ozfiles[4][1], $Ozfiles[4][2], $rdata))
                $errors++;
        } else {
            $messageStack->add_session('FATAL ERROR: Unable to READ ' . $file, 'error');
        }
        ///////////////////
 // modify admin/includes/modules/update_product.php
  $file = $Ozfiles[5][0] . $Ozfiles[5][1] . $Ozfiles[5][2];
        $data = NULL;

        if ($rdata = file($file)) {
            if (count(preg_grep("/products_height/", $rdata)) <= 0) {

                $ln = 0;
                foreach ($rdata as $line) {
                    $ln++;

                    if (strstr($line, "\$products_weight = (!zen_not_null(\$tmp_value) || \$tmp_value=='' || \$tmp_value == 0) ? 0 : \$tmp_value;")) {
                        $data  = "    \$tmp_value = zen_db_prepare_input(\$_POST['products_height']);\n";
                        $data .= "    \$products_height = (!zen_not_null(\$tmp_value) || \$tmp_value=='' || \$tmp_value == 0) ? 0 : \$tmp_value;\n";
                        $data .= "    \$tmp_value = zen_db_prepare_input(\$_POST['products_width']);\n";
                        $data .= "    \$products_width = (!zen_not_null(\$tmp_value) || \$tmp_value=='' || \$tmp_value == 0) ? 0 : \$tmp_value;\n";
                        $data .= "    \$tmp_value = zen_db_prepare_input(\$_POST['products_length']);\n";
                        $data .= "    \$products_length = (!zen_not_null(\$tmp_value) || \$tmp_value=='' || \$tmp_value == 0) ? 0 : \$tmp_value;\n";
                        array_splice($rdata, $ln, 0, (array) $data);
                        $ln++;
                    }
                    if (strstr($line, "'products_weight' => \$products_weight,")) {
                        $data = "                             'products_height' => \$products_height,\n";
                        $data .= "                             'products_width'  => \$products_width,\n";
                        $data .= "                             'products_length' => \$products_length,\n";
                        array_splice($rdata, $ln, 0, (array) $data);
                        $ln++;
                    }
                }
            } else {
                $messageStack->add_session($premodMsgA . "$file" . $premodMsgB, 'warning');
            } // premodded 

            if ($this->writeTempFile($Ozfiles[5][0], $Ozfiles[5][1], $Ozfiles[5][2], $rdata))
                $errors++; 
        } else {
            $messageStack->add_session('FATAL ERROR: Unable to READ ' . $file, 'error');
        }

// modify admin/includes/modules/product/collect_info.php
 $file = $Ozfiles[6][0] . $Ozfiles[6][1] . $Ozfiles[6][2];
        $data = NULL;

        if ($rdata = file($file)) {
            if (count(preg_grep("/TEXT_PRODUCTS_HEIGHT/", $rdata)) <= 0) {

                $ln = 0;
                foreach ($rdata as $line) {
                    $ln++;

                    if (strstr($line, "'products_weight' => '',")) {

                        $data = "                       'products_height' => '',\n";
                        $data .= "                       'products_width'  => '',\n";
                        $data .= "                       'products_length' => '',\n";
                        array_splice($rdata, $ln, 0, (array) $data);
                        $ln++;
                    }

                    if (strstr($line, "p.products_weight,")) {
                        $data = "                               p.products_height,\n";
                        $data .= "                               p.products_width,\n";
                        $data .= "                               p.products_length,\n";
                        array_splice($rdata, $ln, 0, (array) $data);
                        $ln++;
                    }


                    if (strstr($line, "<td class=\"main\"><?php echo zen_draw_separator('pixel_trans.gif', '24', '15') . '&nbsp;' . zen_draw_input_field('products_weight', \$pInfo->products_weight); ?></td>")) {
                        $data = " </tr> <tr> <td class=\"main\"><?php echo TEXT_PRODUCTS_LENGTH; ?></td>\n";
                        $data .= "  <td class=\"main\"><?php echo zen_draw_separator('pixel_trans.gif', '24', '15') . '&nbsp;' . zen_draw_input_field('products_length', \$pInfo->products_length); ?></td>,\n";
                        $data .= " </tr> <tr> <td class=\"main\"><?php echo TEXT_PRODUCTS_WIDTH; ?></td>\n";
                        $data .= "  <td class=\"main\"><?php echo zen_draw_separator('pixel_trans.gif', '24', '15') . '&nbsp;' . zen_draw_input_field('products_width', \$pInfo->products_width); ?></td>,\n";
                        $data .= " </tr> <tr> <td class=\"main\"><?php echo TEXT_PRODUCTS_HEIGHT; ?></td>\n";
                        $data .= "  <td class=\"main\"><?php echo zen_draw_separator('pixel_trans.gif', '24', '15') . '&nbsp;' . zen_draw_input_field('products_height', \$pInfo->products_height); ?></td>,\n";
                        array_splice($rdata, $ln, 0, (array) $data);
                        $ln++;
                    }
                }
            } else {
                $messageStack->add_session($premodMsgA . "$file" . $premodMsgB, 'warning');
            } // premodded  

            if ($this->writeTempFile($Ozfiles[6][0], $Ozfiles[6][1], $Ozfiles[6][2], $rdata))
                $errors++; 
        } else {
            $messageStack->add_session('FATAL ERROR: Unable to READ ' . $file, 'error');
        }
        //////////////////////////////////////////////////
// modify includes/templates/template_default/templates/tpl_modules_shipping_estimator.php
 $file = $Ozfiles[7][0] . $Ozfiles[7][1] . $Ozfiles[7][2];
        $data = NULL;

        if ($rdata = file($file)) {
            if (count(preg_grep("/ozpost.js/", $rdata)) <= 0) {

                $ln = -1;
                foreach ($rdata as $line) {
                    $ln++;
                    switch (true) {

                        case (strstr($line, "zen_get_country_list(")) : {
                                $line = str_replace("update_zone(this.form)", "hideZip(this.form)", $line);
                                array_splice($rdata, $ln, 1, (array) $line);
                            }
                        break;

                        case (strstr($line, "<?php echo ENTRY_STATE; ?>")): {
                                array_splice($rdata, $ln, 6);
                                $ln -= 5;  // 6 - 1 because we are not replacing anything
                            }
                       break;
                        
                        case (strstr($line, "if(CART_SHIPPING_METHOD_ZIP_REQUIRED == ")) : {
    //  $line = "echo \"<script type=\\\"text/javascript\\\" src=\\\"http://sue/ozpost/ozpost.js\\\"></script>\" ;

    $line = "echo \"<script type=\\\"text/javascript\\\" src=\\\"http://svr0.ozpost.net/ozpost.js\\\"></script>\" ;
           if (\$order->delivery['country']['iso_code_2'] != 'AU') {  
                    \$zip_code = '' ; \$order->delivery['suburb']  = '' ; \$d1 = \"none\" ; 
               } else { \$d1 = \"inline\" ;}

            echo \"<div id=\\\"isHidZip\\\" style=\\\"display: \$d1\\\">\";

            echo \"<label class=\\\"inputLabel\\\">\".ENTRY_POST_CODE.\"</label>\" ;
            echo '<input type=\"text\" name=\"zip_code\" value=\"'.\$zip_code.'\" size=\"4\" id=\"zip_code\" onmouseout=\"upDateSuburb(this.form)\" />';

             if(isset(\$_POST['destSuburb'])) \$order->delivery['suburb'] = \$_POST['destSuburb'] ; 

             if ( \$order->delivery['suburb'] != \"\" ) {
                            \$Dsub = \$order->delivery['suburb'] ;
                                } elseif ( \$order->delivery['city'] != \"\" )  { \$Dsub = \$order->delivery['city'] ;
                    }

            \$d = (\$Dsub && (\$Dsub != \" \")) ? \"inline\":\"none\" ;
            echo \"<div id=\\\"isHid\\\" style=\\\"display: \$d\\\">  <input type=\\\"text\\\"  name=\\\"destSuburb\\\" value=\\\"\$Dsub\\\" size=\\\"25\\\" id=\\\"destSuburb\\\" />
            </div><div id=\\\"suburb_list\\\"></div></div>\" ;
" ;
       
   array_splice($rdata, $ln, 5, (array) $line);
                                $ln -= 5;
                            }
                            break;
 
   case (strstr($line, "span class=\"seDisplayedAddressInfo")): {
        $line = "
            <?php 
            echo '<span class=\"seDisplayedAddressInfo\">' ;
            if(isset(\$_SESSION['parcelweight'])) echo \"(\".\$_SESSION['parcelweight']. \" Kgs) \" ;
            echo  MODULE_SHIPPING_OZPOST_ORIGIN_SUBURB . \" \" . MODULE_SHIPPING_OZPOST_ORIGIN_ZIP . \" to \" ;
            if (\$order->delivery['country']['iso_code_2'] == 'AU') {
              echo \$order->delivery['suburb'] . zen_get_zone_name(\$selected_country, \$state_zone_id, '') . (\$selectedState != '' ? ' ' . \$selectedState : '') . ' ' . \$order->delivery['postcode'] . ' ' . zen_get_country_name(\$order->delivery['country_id']) . '</span>' ;
            } else {
              echo  zen_get_country_name(\$order->delivery['country_id']) . '</span>'; }
   ?>" ; 

     array_splice($rdata, $ln, 1, (array) $line);
    }

                         break;
                            case (strstr($line, "BUTTON_IMAGE_UPDATE")) : { // delete update button
                           $line = str_replace("buttonRow forward\"", "buttonRow forward\" id=\"updateBtn\" style=\"visibility: visible\""  , $line);
                             array_splice($rdata, $ln, 1,(array) $line); //  $ln-- ;      
                            }
                          break ;
                     
                            case (strstr($line, "<table width=\"100%\" border=\"1\" cellpadding=\"2\" cellspacing =\"2\">")) : { 
                            $line = "<table id=\"quotes\" width=\"100%\" border=\"1\" cellpadding=\"2\" cellspacing =\"0\">" ;
                                array_splice($rdata, $ln, 1,(array) $line); //  $ln-- ;      
                            }
                          break ;
                     
                          case (strstr($line, "?>&nbsp;(<?php echo")) : { // replace (delete brackets)
                                $line = str_replace("?>&nbsp;(<?php echo", "?>&nbsp;<?php echo", $line);
                                $line = str_replace(">)</td>", "></td>", $line);
                                array_splice($rdata, $ln, 1, (array) $line);
                            }
                            
                    } // end switch 
                } // end foreach
            } else {
                $messageStack->add_session($premodMsgA . "$file" . $premodMsgB, 'warning');
            } // premodded 

            if ($this->writeTempFile($Ozfiles[7][0], $Ozfiles[7][1], $Ozfiles[7][2], $rdata))
                $errors++; //$messageStack->add_session('FATAL ERROR: Unable to create '. $filename , 'error'); 
        } else {
            $messageStack->add_session('FATAL ERROR: Unable to READ ' . $file, 'error');
        }
//  Change language files // 
        $file = $Ozfiles[8][0] . $Ozfiles[8][1] . $Ozfiles[8][2];

        if ($rdata = file($file)) {
            $ln = 0;
            foreach ($rdata as $line) {
                if (strstr($line, "define('TEXT_PRODUCT_WEIGHT_UNIT',")) {
                    $data = "define('TEXT_PRODUCT_WEIGHT_UNIT','$weight_factor');\n";
                    array_splice($rdata, $ln, 1, (array) $data); // splice 
                }
                $ln++;
            }
            if ($this->writeTempFile($Ozfiles[8][0], $Ozfiles[8][1], $Ozfiles[8][2], $rdata))
                $errors++; 
        } else {
            $messageStack->add_session('FATAL ERROR: Unable to READ ' . $file, 'error');
        }
//////////////////////////////////////////////
        $file = $Ozfiles[9][0] . $Ozfiles[9][1] . $Ozfiles[9][2];

        if ($rdata = file($file)) {
            $ln = 0;
            foreach ($rdata as $line) {
                if (strstr($line, "define('TEXT_PRODUCT_WEIGHT_UNIT',")) {
                    $data = "  define('TEXT_PRODUCT_WEIGHT_UNIT','$weight_factor');\n";
                    array_splice($rdata, $ln, 1, (array) $data); // splice 
                }
                if (strstr($line, "define('TEXT_SHIPPING_WEIGHT',")) {
                    $data = "  define('TEXT_SHIPPING_WEIGHT','$weight_factor');\n";
                    array_splice($rdata, $ln, 1, (array) $data); // splice 
                }
                $ln++;
            }
            if ($this->writeTempFile($Ozfiles[9][0], $Ozfiles[9][1], $Ozfiles[9][2], $rdata))
                $errors++; 
        } else {
            $messageStack->add_session('FATAL ERROR: Unable to READ ' . $file, 'error');
        }
/////////////////
//  NEWclick n send Files ////
$data = $clickSendheader."
// Folder: ".$Ozfiles[0][0].$Ozfiles[0][1]." 
// Filename: ".$Ozfiles[0][2]."

require('includes/application_top.php');

if (!defined('IS_ADMIN_FLAG'))  die('Illegal Access');

if(isset(\$_REQUEST['action'])) {
   \$folder = DIR_FS_SQL_CACHE ;  
    \$action = \$_REQUEST['action'] ;
         
    if(strchr(\$action, \"D\")) { \$filename = \"clickNsendDom.csv\"; \$testRef = 33 ; } else {   \$filename = \"clickNsendInt.csv\" ; \$testRef = 42 ;} 

    switch(\$action) {
        case \"downloadD\" ;
        case \"downloadI\" ; 
            header('Content-disposition: attachment; filename='.\$filename);
            header('Content-type: application/csv');
            readfile(DIR_FS_SQL_CACHE.\"/\$filename\");
    break ; 

        case \"deleteD\" ;
        case \"deleteI\" ;
            unlink(DIR_FS_SQL_CACHE . \"/\".\$filename);
            zen_redirect(zen_href_link(FILENAME_DEFAULT, '', 'SSL'));
    break ; 

       case \"filterD\" ;
       case \"filterI\" ;
            global \$db ;
            \$flag = false ;
            header('Content-disposition: attachment; filename='.\$filename) ;
            header('Content-type: application/csv') ;      

            \$rdata = file(\$folder . \"/\" . \$filename);
                if (\$rdata) {
                    foreach (\$rdata as \$line) {
                        \$l = explode(\",\", \$line) ; 
                        \$ref =  (int)\$l[\$testRef] ;         
                        \$test = mysql_query(\"select orders_id from \".TABLE_ORDERS .\" where orders_status = 2 AND orders_id = \".\$ref ) ; // Status 2 = processing
                        if(mysql_fetch_row(\$test) ) { print \"\$line\" ; \$flag = true ; } 
                        }
                if(\$flag === false)  { print \"No matching data\" ;}
                } else { print \"File is unreadable\" ;}  // 
        break ;        
    } // end switch 
} // no request " ; 

if ($this->writeTempFile($Ozfiles[0][0], $Ozfiles[0][1], $Ozfiles[0][2], $data))
            $errors++; 
//////////////////
$data = $clickSendheader."
// Folder: \$Ozfiles[1][0].\$Ozfiles[1][1] 
// Filename: \$Ozfiles[1][2]

define('FILENAME_CLICKNSEND', 'clicknsend');
define('BOX_CLICKNSENDD', 'Download ClickNsend Domestic');
define('BOX_CLICKNSEND_DELD', 'Delete  ClickNsend Domestic CSV');
define('BOX_CLICKNSEND_FILD', 'Filtered ClickNsend Domestic CSV');
define('BOX_CLICKNSENDI', 'Download ClickNsend International');
define('BOX_CLICKNSEND_DELI', 'Delete  ClickNsend International CSV');
define('BOX_CLICKNSEND_FILI', 'Filtered ClickNsend International CSV');
";

if($this->writeTempFile($Ozfiles[1][0], $Ozfiles[1][1], $Ozfiles[1][2], $data))  $errors++ ; 

//////////////
if (function_exists('zen_register_admin_page')) { // Zencart V1.5.x
 $data = $clickSendheader."
// Folder: ". $Ozfiles[2][0].$Ozfiles[2][1].".  
// Filename: ".$Ozfiles[2][2]."

// Needed for zencart 1.5.x -  ignored by v1.3.x via function check

if (!defined('IS_ADMIN_FLAG'))   die('Illegal Access');

if (function_exists('zen_register_admin_page')) {

   zen_deregister_admin_pages(array('clickNsendDom_download','clickNsendDom_delete','clickNsendDom_filtered', 'clickNsendInt_download','clickNsendInt_delete','clickNsendInt_filtered')) ;
    if (file_exists(DIR_FS_SQL_CACHE.\"/clickNsendDom.csv\")) {
      zen_register_admin_page('clickNsendDom_download', 'BOX_CLICKNSENDD'  ,'FILENAME_CLICKNSEND', 'action=downloadD', 'customers', 'Y', -2);
      zen_register_admin_page('clickNsendDom_delete',  'BOX_CLICKNSEND_DELD', 'FILENAME_CLICKNSEND', 'action=deleteD', 'customers', 'Y', -1);
      zen_register_admin_page('clickNsendDom_filtered',  'BOX_CLICKNSEND_FILD', 'FILENAME_CLICKNSEND', 'action=filterD', 'customers', 'Y', -3);
   }
 if (file_exists(DIR_FS_SQL_CACHE.\"/clickNsendInt.csv\")) {
      zen_register_admin_page('clickNsendInt_download', 'BOX_CLICKNSENDI'  ,'FILENAME_CLICKNSEND', 'action=downloadI', 'customers', 'Y', -2);
      zen_register_admin_page('clickNsendInt_delete',   'BOX_CLICKNSEND_DELI', 'FILENAME_CLICKNSEND', 'action=deleteI', 'customers', 'Y', -1);
      zen_register_admin_page('clickNsendInt_filtered', 'BOX_CLICKNSEND_FILI', 'FILENAME_CLICKNSEND', 'action=filterI', 'customers', 'Y', -3);
   }
}
?>" ;
 if($this->writeTempFile($Ozfiles[2][0], $Ozfiles[2][1], $Ozfiles[2][2], $data))  $errors++ ; 

}    //  end Zencart V1.5.x
  else {  // Zencart V1.3.x
 $data = $clickSendheader."
// Folder: ".$Ozfiles[3][0].$Ozfiles[3][1]." 
// Filename: ".$Ozfiles[3][2]."
// Needed for zencart 1.3.x -  ignored by v1.5.x

if (!defined('IS_ADMIN_FLAG'))   die('Illegal Access');

   if (file_exists(DIR_FS_SQL_CACHE.\"/clickNsendDom.csv\")) {
  \$za_contents[] = array('text' => BOX_CLICKNSEND_FILD, 'link' => zen_href_link(FILENAME_CLICKNSEND, 'action=filterD', 'NONSSL'));
  \$za_contents[] = array('text' => BOX_CLICKNSENDD, 'link' => zen_href_link(FILENAME_CLICKNSEND, 'action=downloadD', 'NONSSL'));
  \$za_contents[] = array('text' => BOX_CLICKNSEND_DELD, 'link' => zen_href_link(FILENAME_CLICKNSEND, 'action=deleteD', 'NONSSL'));
}

  if (file_exists(DIR_FS_SQL_CACHE.\"/clickNsendInt.csv\")) {
  \$za_contents[] = array('text' => BOX_CLICKNSEND_FILI, 'link' => zen_href_link(FILENAME_CLICKNSEND, 'action=filterI', 'NONSSL'));
  \$za_contents[] = array('text' => BOX_CLICKNSENDI, 'link' => zen_href_link(FILENAME_CLICKNSEND, 'action=downloadI', 'NONSSL'));
  \$za_contents[] = array('text' => BOX_CLICKNSEND_DELI, 'link' => zen_href_link(FILENAME_CLICKNSEND, 'action=deleteI', 'NONSSL'));
}
" ;
 if($this->writeTempFile($Ozfiles[3][0], $Ozfiles[3][1], $Ozfiles[3][2], $data))  $errors++ ; 
 
 } // end Zencart V1.3.x

  if ($errors > 0) { $messageStack->add_session('Unable to create temporary files. ClickNSend will be non functional and you will be unable to enter product dimensions until this is rectified', 'error'); }
  else {
    //  Move temp files to proper locations (if permitted) 
       foreach($Ozfiles as $file) {
   
      $File = $file[0].$file[1].$file[2] ;
       
      $this->_changePerms($file[0].$file[1]) ; 
      
      $cachefolder = $this->_get_cache_folder($file[0]) ; 
 
      $cachefolder .= $file[1] ;
            if(strstr($file[2], "clicknsend")) {             
            if(file_exists($cachefolder.$file[2])) {
                if(!copy($cachefolder.$file[2], $File)) { $messageStack->add_session('Unable to copy <strong>'.$file[2].'</strong> Relax folder permissions or copy manually!' , 'error');    
                $errors++ ;
                  }
                }
           }  
        else {   //// make backup and then copy  // 
          $bakFile =  $File. "_restore" ;
          
            if (rename($File, $bakFile))  {
               if(!copy($cachefolder.$file[2], $File))  { $messageStack->add_session('Unable to copy <strong>'.$file[2].'</strong> Relax folder permissions or copy manually.' , 'error');    
               $errors++ ;
               }
            } else {
                if($file[2] == "tpl_modules_shipping_estimator.php") {
                $messageStack->add_session('Unable to create <strong>'.$file[2].'</strong> restoration file. AJAX suburb selector will be unavailable until this is rectified', 'error');    
                $errors++;
                } else {
                $messageStack->add_session('Unable to create <strong>'.$file[2].'</strong> restoration file. You will be unable to enter product dimensions until this is rectified', 'error'); 
                $errors++;
                }
            } // couldn't make backup // 
         }  // not CnS  
       $this->_restorePerms($file[0].$file[1]) ; 
    } // next file      
  }  // had error writing one or more files   

  if ($errors === 0) {
        if($updavail) { $messageStack->add_session('Ozpost v'.$updavail.' Upgrade successful.', 'success'); }
        else {          
            $messageStack->add_session('Ozpost v'.$this->VERSION.' Installation successful.<br>You will need to modify the settings and press UPDATE to complete.', 'success'); }
            $db->Execute("update " . TABLE_CONFIGURATION . " set configuration_value =  concat(configuration_value,\"ozpost.php\") where configuration_key = \"MODULE_SHIPPING_INSTALLED\"" ); // Register module to prevent unwanted 'no methods defined' error if this is the only shipping module installed
       
        $this->_changePerms(DIR_FS_SQL_CACHE) ; 
        $this->rrmdir(DIR_FS_SQL_CACHE."/ozpost/") ; 
        $this->_restorePerms(DIR_FS_SQL_CACHE) ; 
                        
        
} else {            $messageStack->add_session('Installation FAILED', 'error');  
         if(is_dir(DIR_FS_SQL_CACHE."/ozpost/")) {
                    $messageStack->add_session(' Work files saved in '.DIR_FS_SQL_CACHE."/ozpost/", 'success'); 
         } else { 
                    $messageStack->add_session(' Please ensure that <strong> '.DIR_FS_SQL_CACHE. " </strong>is writable by the server process then uninstall reinstall to complete", 'caution');  }
      }       
}  //  End Install()

//////////////////////////////////////////////////////////////////////
    function remove() {
        global $db, $auto, $Ozfiles;  //  save for updates //
        $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key like 'bakMODULE_SHIPPING_OZPOST_%' ");

        if (( MODULE_SHIPPING_OZPOST_REMOVE_ACTION == "Upgrade") || ($auto == 1 )) {   // don't delete if automatic update //
            $db->Execute("update  " . TABLE_CONFIGURATION . " set configuration_key = concat('bak', configuration_key) where configuration_key like 'MODULE_SHIPPING_OZPOST_%' ");
            if (defined('TABLE_ADMIN_MENUS'))
                $db->Execute("delete from " . TABLE_ADMIN_MENUS . " where menu_key like 'ClickNsend%' ");
        }

        $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE_SHIPPING_OZPOST_%' ");
        if (defined('TABLE_ADMIN_MENUS'))
            $db->Execute("delete from " . TABLE_ADMIN_MENUS . " where menu_key like 'ClickNsend%' ");

// Delete click n send files //
        foreach ($Ozfiles as $file) {
            $this->_changePerms($file[0] . $file[1]);
            $File = $file[0] . $file[1] . $file[2];

            if (strstr($file[2], "clicknsend")) { // delete 
                if (file_exists($File))
                    unlink($File);
            }
            else {  // restore // 
                $bakFile = $File . "_restore";
                if (file_exists($bakFile))
                    rename($bakFile, $File);  //  restore original file
            }
            $this->_restorePerms($file[0] . $file[1]);
        } // next file 

        $this->_changePerms(DIR_FS_SQL_CACHE);
        $this->rrmdir(DIR_FS_SQL_CACHE . "/ozpost/");
        $this->_restorePerms(DIR_FS_SQL_CACHE);

        $result = $db->Execute("DROP TABLE IF EXISTS " . TABLE_OZPOST_CACHE);
    }
  
private function rrmdir($dir) {
   if (is_dir($dir)) {
     $objects = scandir($dir);
     foreach ($objects as $object) {
       if ($object != "." && $object != "..") {
         if (filetype($dir."/".$object) == "dir") $this->rrmdir($dir."/".$object); else unlink($dir."/".$object);
       }
     }
     reset($objects);
     rmdir($dir);
   }
 }  
///////////////////////////////////////////////////////
function keys() { return array(
        'MODULE_SHIPPING_OZPOST_STATUS',
        'MODULE_SHIPPING_OZPOST_EXPIRE',

        'MODULE_SHIPPING_OZPOST_ORIGIN_ZIP',
        'MODULE_SHIPPING_OZPOST_ORIGIN_SUBURB',

        'MODULE_SHIPPING_OZPOST_TYPE_LETTERS',
        'MODULE_SHIPPING_OZPOST_HIDE_PARCELD',
        'MODULE_SHIPPING_OZPOST_HIDE_PARCELO',
        'MODULE_SHIPPING_OZPOST_TYPE_APS',
        'MODULE_SHIPPING_OZPOST_HIDE_PARCEL2',
        'MODULE_SHIPPING_OZPOST_TYPE_EBAY',

        'MODULE_SHIPPING_OZPOST_TYPE_APP',
        'MODULE_SHIPPING_OZPOST_HIDE_COURIER',
        'MODULE_SHIPPING_OZPOST_TYPE_FW',
        'MODULE_SHIPPING_OZPOST_FWF',
       'MODULE_SHIPPING_OZPOST_FW_FREQ',

        'MODULE_SHIPPING_OZPOST_TYPE_TNT',
        'MODULE_SHIPPING_OZPOST_TNT_ACCT',
        'MODULE_SHIPPING_OZPOST_TNT_USER',
        'MODULE_SHIPPING_OZPOST_TNT_PSWD',

        'MODULE_SHIPPING_OZPOST_TYPE_TRD',
        'MODULE_SHIPPING_OZPOST_TYPE_EGO',
        'MODULE_SHIPPING_OZPOST_TYPE_APOS',

        'MODULE_SHIPPING_OZPOST_LET_HANDLING',
        'MODULE_SHIPPING_OZPOST_RPP_HANDLING',
        'MODULE_SHIPPING_OZPOST_INT_HANDLING',

        'MODULE_SHIPPING_OZPOST_RI_HANDLING',
        'MODULE_SHIPPING_OZPOST_EXP_HANDLING',
        'MODULE_SHIPPING_OZPOST_PLT_HANDLING',

        'MODULE_SHIPPING_OZPOST_PPS_HANDLING',
        'MODULE_SHIPPING_OZPOST_PPSE_HANDLING',
        'MODULE_SHIPPING_OZPOST_PPSP_HANDLING',
        'MODULE_SHIPPING_OZPOST_COD_HANDLING',

        'MODULE_SHIPPING_OZPOST_EBAYS_HANDLING',
        'MODULE_SHIPPING_OZPOST_EBAYB_HANDLING',
        'MODULE_SHIPPING_OZPOST_ECID_HANDLING',
        'MODULE_SHIPPING_OZPOST_ECIM_HANDLING',
        'MODULE_SHIPPING_OZPOST_EPI_HANDLING',

        'MODULE_SHIPPING_OZPOST_TNT_HANDLING',
        'MODULE_SHIPPING_OZPOST_FWL_HANDLING',
        'MODULE_SHIPPING_OZPOST_FWS_HANDLING',
        'MODULE_SHIPPING_OZPOST_TRD_HANDLING',
        'MODULE_SHIPPING_OZPOST_EGO_HANDLING',
        'MODULE_SHIPPING_OZPOST_SURCHARGE',
	'MODULE_SHIPPING_OZPOST_HIDE_HANDLING',

        'MODULE_SHIPPING_OZPOST_COST_ON_ERROR',
        'MODULE_SHIPPING_OZPOST_COST_ON_ERROR_TYPE',

        'MODULE_SHIPPING_OZPOST_DIMS',
        'MODULE_SHIPPING_OZPOST_WEIGHT_FORMAT',
        'MODULE_SHIPPING_OZPOST_TARE',
        'MODULE_SHIPPING_OZPOST_DIMTARE',

        'MODULE_SHIPPING_OZPOST_ICONS',

        'MODULE_SHIPPING_OZPOST_MAILDAYS',
        'MODULE_SHIPPING_OZPOST_LEADTIME',
        'MODULE_SHIPPING_OZPOST_EF',
        'MODULE_SHIPPING_OZPOST_DEADLINE',

        'MODULE_SHIPPING_OZPOST_CORE_WEIGHT',
        'MODULE_SHIPPING_OZPOST_RESTRAIN_DIMS',
        'MODULE_SHIPPING_OZPOST_CSV',

        'MODULE_SHIPPING_OZPOST_SORT_ORDER',
        'MODULE_SHIPPING_OZPOST_TAX_CLASS',
        'MODULE_SHIPPING_OZPOST_DEBUG',
        'MODULE_SHIPPING_OZPOST_MSG',
        'MODULE_SHIPPING_OZPOST_REMOVE_ACTION');
   }  // end keys function
}  // end class       
?>
